/*  WindPattern.c			
* calcul patrons de la forme 3d  ...

* issue de WindShape ou gnr  partir d'une autre application

* mais respectant le format WindShape !
*/



/***********/

/* include */

/***********/


#include <stdlib.h>

#include <stdio.h>

#include <string.h>

#include <math.h>

#include <GL/glut.h>


#include <afx.h>		//class CString

#include <afxdlgs.h>	//class CFileDialog



#include "../commun/matrice.h"

#include "../commun/geom.h"

#include "../commun/plot.h"

#include "../commun/fichier.h"

#include "../commun/glui.h"



/**********/

/* define */

/**********/



#define AUTEUR_DATE "(Thierry Pebayle - 18/08/2002)"

#define sqr(f1) ((f1)*(f1))



/**********************/

/* variables globales */

/**********************/



/*live-variable GLUI*/

int VisuFace=0;		/*choix visu nervures(0) ou surfaces(1)*/

int ProjOrthoPers=0;	/*choix projection orthogonale ou perspective*/

int	VisuSymetrique=1;	/*visualise les 2 ou 1 moiti de l'aile en 3D*/

int VisuPtsSuspentes=1; /*visualise pts de suspentage*/

int ReperesCoutures=1;

int ReperesSuspentes[2]={1,1};

int Numerotation=1;

int Ventilation=0;



//pour calcul patrons

int NoNerv[2]={9,10};

float Deb[2]={0.0f,20.0f}, Fin[2]={100.0f, 80.0f};

int FaceDeb[2], FaceFin[2];

float Marge[2]={1.0f, 1.0f};

float PosRep[2];

int FaceRep[2];

float MargeDeb=1.0f, MargeFin=1.0f;

//pinces !!!

float PosPinceBA[2]={0.0,0.0};

float PosPinceBF[2]={0.0,0.0};

float AmpPinceBA[2]={0.0,0.0};

float AmpPinceBF[2]={0.0,0.0};

float modePinces = 1.0f;



//pour zoom patron

int zoomIN=false, debZoomIN=false, finZoomIN=false, zoomOUT=false, quitZoom=false;

TCourbe *CourbZoom;



/*global pour control rotation, ...*/

int xSouris, ySouris;		/*coordonnes fenetre de la souris*/

int Rotation3d = OFF;		/*flag rotation 3d -> bouton gauche souris*/

int Translation3d = OFF;	/*flag translation 3d -> bouton droit souris*/

int ZoomTwist3d = OFF;		/*flag twist 3d -> bouton gauche et droit souris*/



/*fenetres OpenGL*/

int Fenetre3d;		/*visu 3D*/

int FenetrePatron;	/*visu patron*/



/* axes graphiques*/

TAxe *Axe3d;		

TAxe *AxeSel;

TAxe *AxePatron; 



/*forme*/

TForme *F;



/*divers tableaux*/

TMatrice *IntProfCent, *ExtProfCent, *IntProfBout ,*ExtProfBout;





char NomFichierForme[255];



GLUI *glui;

GLUI_StaticText *FicForme;

GLUI_Spinner *SpinNoNerv[2];



/***********************************************/

/*liste des procedures definies dans ce fichier*/

/***********************************************/



void display(void);

void reshape(int w, int h);

void motion(int x, int y);

void BoutonSouris(int button, int state, int x, int y);

void PositionneFenetres(void);

void keyboard(unsigned char key, int x, int y);

void InitFenetre(void);

void InitLumiere(void);



void CalculVue3dEtPatron(void);



void ModifProjection3d( int control );

void ModifVisu3d( int control );

void ModifVisuSymetrique( int control );



void Appliquer( int control );

void Quitter( int control );

void Info( int control );



void ChargerFichierForme( int control );



void CalculPatron(void);

void InitValeursDialogue(void);

void Ajouter( int control );



/***********************/

/* InitValeursDialogue */

/***********************/

void InitValeursDialogue(void)

{

	NoNerv[0]=0; NoNerv[1]=1;

	Deb[0]=0.0f; Deb[1]=0.0f;

	Fin[0]=100.0f; Fin[1]=100.0f;

	FaceDeb[0]=1; FaceDeb[1]=1;

	FaceFin[0]=1; FaceFin[1]=1;

	Marge[0]=1.0f; Marge[1]=1.0f;

	PosRep[0]=0.0f; PosRep[1]=0.0f;

	FaceRep[0]=1; FaceRep[1]=1;

	MargeDeb=1.0f, MargeFin=1.0f;

	SpinNoNerv[0] -> set_int_limits( -1, F->TabForme->lig-1 );

	SpinNoNerv[1] -> set_int_limits( -1, F->TabForme->lig-1 );

	glui->sync_live();

}



/***********************/

/* ChargerFichierForme */

/***********************/

void ChargerFichierForme( int control )

{

	CString NomFichier;

	char* PtrNomFichier;

	TForme* oldF;

	

	//ouverture boite de dialogue

	CFileDialog DlgOpen(TRUE, NULL, "*.txt", OFN_OVERWRITEPROMPT, NULL, NULL);

	if (DlgOpen.DoModal()==IDOK)

	{

		//recupere nom de fichier

		NomFichier=DlgOpen.GetPathName();

		PtrNomFichier=NomFichier.GetBuffer(1);

		strcpy(NomFichierForme, PtrNomFichier);

		

		//lecture fichier de forme

		//LibererForme(F);

		oldF = F;

		F = LectureFichierForme(NomFichierForme);

		

		//libere memoire ancienne forme

		LibererForme(oldF);



		//maj interface GLUI

		FicForme->set_text(NomFichierForme);

		

		//chargement profils

		LectureFichierProfil(F->NomProfilCent, &ExtProfCent, &IntProfCent);

		LectureFichierProfil(F->NomProfilBout, &ExtProfBout, &IntProfBout);

		InterpoleProfilBout(&ExtProfBout, ExtProfCent);

		InterpoleProfilBout(&IntProfBout, IntProfCent);



		//par defaut pas de zoom, et axe automatique

		quitZoom=false;	zoomIN=false; debZoomIN=false; finZoomIN=false;	zoomOUT=false;

		AxePatron->XAuto = ON; AxePatron->YAuto = ON; AxePatron->ZAuto = ON; 

		

		//mise a jour limite/valeur boite de dialogue

		InitValeursDialogue();

	}



	//mise a jour affichage

	CalculVue3dEtPatron(); display();

}





/*********************/

/* ModifProjection3d */

/*********************/

void ModifProjection3d( int control )

{

	/*test type de proj.*/

	if(ProjOrthoPers == 0)

		Axe3d->proj = PROJ_ORTHOGONALE;

	else

		Axe3d->proj = PROJ_PERSPECTIVE;

	/*retrace uniquement la vue 3d*/

	VisuAxe(Axe3d); glutSwapBuffers();

}



/***************/

/* ModifVisu3d */

/***************/

void ModifVisu3d( int control )

{

	/*recalcul et retrace la vue 3d*/

	CalculVue3dEtPatron(); VisuAxe(Axe3d); glutSwapBuffers();

}



/***********************/

/* ModifVisuSymetrique */

/***********************/

void ModifVisuSymetrique( int control )

{

	/*recalcul et retrace la vue 3d*/

	CalculVue3dEtPatron(); VisuAxe(Axe3d); glutSwapBuffers();

}



/***********/

/* Ajouter */

/***********/

void Ajouter( int control )

{

}



/*************/

/* Appliquer */

/*************/

void Appliquer( int control )

{

	int i; //,j;

	TMatrice *xe, *xi;

	TMatrice *extProf, *intProf;

	//int nerv[2];



	//recopie X extrados/intrados du profil central (idem profil extrmit)

	xe=CreerMatrice(ExtProfCent->lig,1); xi=CreerMatrice(IntProfCent->lig,1);

	for(i=0; i<ExtProfCent->lig; i++) xe->t[i][0]=ExtProfCent->t[i][0];

	for(i=0; i<IntProfCent->lig; i++) xi->t[i][0]=IntProfCent->t[i][0];



	//ajoute points intermdaires de Debut et Fin de dvelopp si besoin !!! 

	for(i=0; i<2; i++)

	{

		if((FaceDeb[i]==1)&&(!ValeurPresente(Deb[i],xe)))

			AjouteValeurCroissant(Deb[i],&xe);

		if((FaceDeb[i]==2)&&(!ValeurPresente(Deb[i],xi)))

			AjouteValeurCroissant(Deb[i],&xi);

		if((FaceFin[i]==1)&&(!ValeurPresente(Fin[i],xe)))

			AjouteValeurCroissant(Fin[i],&xe);

		if((FaceFin[i]==2)&&(!ValeurPresente(Fin[i],xi)))

			AjouteValeurCroissant(Fin[i],&xi);

	}



	//interpole profils central et extrmit avec points intermdaires !!!

	extProf=Zeros(xe->lig, 2); intProf=Zeros(xi->lig, 2);

	for(i=0; i<extProf->lig; i++) extProf->t[i][0] = xe->t[i][0];

	for(i=0; i<intProf->lig; i++) intProf->t[i][0] = xi->t[i][0];

	InterpoleProfilBout(&ExtProfBout, extProf);

	InterpoleProfilBout(&IntProfBout, intProf);

	InterpoleProfilBout(&ExtProfCent, extProf);

	InterpoleProfilBout(&IntProfCent, intProf);



	//liberation memoire

	LibererMatrice(xe); LibererMatrice(xi);

	LibererMatrice(extProf); LibererMatrice(intProf);

	

	//par defaut pas de zoom, et axe automatique pour AxePatron

	quitZoom=false;	zoomIN=false; debZoomIN=false; finZoomIN=false;	zoomOUT=false;

	AxePatron->XAuto = ON; AxePatron->YAuto = ON; AxePatron->ZAuto = ON; 

	

	//recalcul forme 3D et patron avec "nouveau" profil

	CalculVue3dEtPatron();

	display();

}



/*************/

/* Sauver    */

/*************/

void Sauver( int dxf )

{

	//boite de dialogue fichier

	CString NomFichier;

	LPTSTR PtrNomFichier;

	//parcours liste des courbes

	TCourbe	*Cour;

	FILE *fid;

	char ext[10];

	int i;



	//ouverture boite de dialogue

	if (dxf) strcpy(ext, "*.dxf"); else strcpy(ext, "*.txt");

	CFileDialog DlgOpen(FALSE, NULL, ext, OFN_OVERWRITEPROMPT, NULL, NULL);

	if (DlgOpen.DoModal()==IDOK)

	{

		//recupere nom de fichier

		NomFichier=DlgOpen.GetPathName();

		PtrNomFichier = NomFichier.GetBuffer(1);



		//ecriture fichier patron

		if(dxf)	//format DXF

		{

			EcritureFichierDXF(PtrNomFichier, AxePatron);

		}

		else //format TXT

		{

			fid=fopen(PtrNomFichier,"wt");

			Cour=AxePatron->Courb;

			while(Cour != NULL)

			{

				fprintf(fid,"\n%d",Cour->pts->lig);

				for(i=0;i<Cour->pts->lig; i++)

					fprintf(fid,"\n%1.5f %1.5f", Cour->pts->t[i][0], Cour->pts->t[i][1]);

				Cour=Cour->CourbSuiv;

			}

		}

	}

}



/***********/

/* Quitter */

/***********/

void Quitter( int control )

{

	/*liberation espace memoire*/

	LibererAxe(Axe3d);

	LibererAxe(AxePatron);

	LibererForme(F);

	LibererMatrice(IntProfCent);

	LibererMatrice(ExtProfCent);

	LibererMatrice(IntProfBout);

	LibererMatrice(ExtProfBout);



	/*quitte interface*/

	//(GLUI_Update_CB)exit;

	exit(0);

}



/********/

/* Info */

/********/

void Info( int control )

{

}



/***********************/

/* CalculVue3dEtPatron */

/***********************/

void CalculVue3dEtPatron(void)

{

	TMatrice *XExt,*YExt,*ZExt; //coordonnes 3D extrados

	TMatrice *XInt,*YInt,*ZInt; //coordonnes 3D intrados

	TMatrice *PtsSuspentes; //pour recuperer la position 3D des pts de suspentage



	//pour developpe patron ...

	int i,j;

	int symetrique[2]={false, false}; //indique si nervure symtrique 

	int nerv[2]; //pour gestion symtrique ...

	TMatrice *X[2], *Y[2], *Z[2]; //coordonnes X,Y,Z des 2 cotes de la surface 3D

	TMatrice *P[2];	// % de la corde du profil

	TMatrice *Xd[2], *Yd[2]; //coordonnes X,Y des 2 cots de la surface developpe

	int iDeb, iFin, iCol;

	TMatrice *xExtProf, *xIntProf;

	TMatrice *iAv, *iAp, *Res;

	TCourbe *CourbPatron[2], *CourbMarge[2];

	TCourbe *CourbAv, *CourbAr, *CourbMargeAv, *CourbMargeAr, *CourbCoin, *CourbRep;

	TMatrice *distance;

	int n; //, iRep;

	float xText, yText;

	char texte[100], texteExtInt[3]="EI";

	//pour calcul position suspentes

	TMatrice *interpXSuspente, *interpYSuspente;

	float posSuspente, xSuspente[2][4], ySuspente[2][4];

	//representation 3d du patron

	TMesh *MeshPatron;

	//pour calcul des pinces

	float longPince, ampPince, amp, larg, longCoteMax;

	TMatrice *longCote[2], *newXd[2], *newYd[2];

	int iPince, iBidon, i0, i1;

	//TCourbe *CourbPince[2];

	//pour cercles de ventilation

	TCourbe *CourbCercle;





	/***********************************/

	/* visu forme et pts de suspentage */

	/***********************************



	//pour visu surface developpe

	TMesh *MeshPatron;



	/*par defaut destruction des courbes ou mesh de l'axe 3D*/

	LibererCourbesAxe(Axe3d); LibererMeshsAxe(Axe3d);



	/*calcul forme*/

	CalculForme3D(F->TabForme,

		ExtProfCent, IntProfCent, ExtProfBout, IntProfBout,

		&XExt, &YExt, &ZExt, &XInt, &YInt, &ZInt);

	

	/*ajoute visu 3D de la forme*/

	AjoutForme3D(Axe3d, XExt, YExt, ZExt, XInt, YInt, ZInt, VisuFace, VisuSymetrique);



	/*ajoute points de suspentage*/

	if(VisuPtsSuspentes){

		AjoutPtsSuspentage(Axe3d, F->TabForme, IntProfCent, XExt, YExt, ZExt, XInt, YInt, ZInt,

			VisuSymetrique, &PtsSuspentes);}



	/***********************/

	/* calcul du patron !!!*/

	/***********************/



	//suppression de l'ancien patron

	LibererCourbesAxe(AxePatron);



	//recopie des X du profil dans 2 vecteurs colonnes

	//pour faciliter ecriture par la suite

	xExtProf = CreerMatrice(ExtProfCent->lig,1);

	xIntProf = CreerMatrice(IntProfCent->lig,1);

	for(i=0; i<ExtProfCent->lig; i++) xExtProf->t[i][0]=ExtProfCent->t[i][0];

	for(i=0; i<IntProfCent->lig; i++) xIntProf->t[i][0]=IntProfCent->t[i][0];



	//prparation des tableaux

	//boucle sur les 2 cotes du dvelopp ...

	for(i=0; i<2; i++)

	{

		//test nervure centrale symtrique

		nerv[i] = NoNerv[i];

		if(NoNerv[i]==-1) {nerv[i]=0; symetrique[i]=true;}



		//test face int/ext

		if ( FaceDeb[i]==1 && FaceFin[i]==1 )	//debut et fin en extrados

		{

			if(Deb[i]>Fin[i]) //inversion Deb<->Fin

			{

				Ind(Fin[i],xExtProf,&iDeb,&iCol);

				Ind(Deb[i],xExtProf,&iFin,&iCol);

			}

			else

			{

				Ind(Deb[i],xExtProf,&iDeb,&iCol);

				Ind(Fin[i],xExtProf,&iFin,&iCol);

			}

			X[i] = CreerMatrice(iFin-iDeb+1, 1);

			Y[i] = CreerMatrice(iFin-iDeb+1, 1);

			Z[i] = CreerMatrice(iFin-iDeb+1, 1);

			P[i] = CreerMatrice(iFin-iDeb+1, 1);

			for(j=0; j<X[i]->lig; j++) X[i]->t[j][0] = XExt->t[nerv[i]][iDeb+j];

			for(j=0; j<Y[i]->lig; j++) Y[i]->t[j][0] = YExt->t[nerv[i]][iDeb+j];

			for(j=0; j<Z[i]->lig; j++) Z[i]->t[j][0] = ZExt->t[nerv[i]][iDeb+j];

			for(j=0; j<P[i]->lig; j++) P[i]->t[j][0] = xExtProf->t[iDeb+j][0];

		}

		else if ( FaceDeb[i]==1 ) //debut en extrados et fin en intrados

		{

			Ind(Deb[i],xExtProf,&iDeb,&iCol);

			Ind(Fin[i],xIntProf,&iFin,&iCol);

			X[i] = CreerMatrice(iFin+iDeb-1, 1);

			Y[i] = CreerMatrice(iFin+iDeb-1, 1);

			Z[i] = CreerMatrice(iFin+iDeb-1, 1);

			P[i] = CreerMatrice(iFin+iDeb-1, 1);

			for(j=0; j<=iDeb; j++)			X[i]->t[j][0] = XExt->t[nerv[i]][iDeb-j];

			for(j=iDeb+1; j<X[i]->lig; j++) X[i]->t[j][0] = XInt->t[nerv[i]][j-iDeb];

			for(j=0; j<=iDeb; j++)			Y[i]->t[j][0] = YExt->t[nerv[i]][iDeb-j];

			for(j=iDeb+1; j<X[i]->lig; j++) Y[i]->t[j][0] = YInt->t[nerv[i]][j-iDeb];

			for(j=0; j<=iDeb; j++)			Z[i]->t[j][0] = ZExt->t[nerv[i]][iDeb-j];

			for(j=iDeb+1; j<X[i]->lig; j++) Z[i]->t[j][0] = ZInt->t[nerv[i]][j-iDeb];

			for(j=0; j<=iDeb; j++)			P[i]->t[j][0] = xExtProf->t[iDeb-j][0];

			for(j=iDeb+1; j<X[i]->lig; j++) P[i]->t[j][0] = xIntProf->t[j-iDeb][0];

		}

		else if ( FaceFin[i]==1 ) //debut en intrados et fin en extrados

		{

			Ind(Deb[i],xIntProf,&iDeb,&iCol);

			Ind(Fin[i],xExtProf,&iFin,&iCol);

			X[i] = CreerMatrice(iFin+iDeb+1, 1);

			Y[i] = CreerMatrice(iFin+iDeb+1, 1);

			Z[i] = CreerMatrice(iFin+iDeb+1, 1);

			P[i] = CreerMatrice(iFin+iDeb+1, 1);

			for(j=0; j<=iDeb; j++)			X[i]->t[j][0] = XInt->t[nerv[i]][iDeb-j];

			for(j=iDeb+1; j<X[i]->lig; j++) X[i]->t[j][0] = XExt->t[nerv[i]][j-iDeb];

			for(j=0; j<=iDeb; j++)			Y[i]->t[j][0] = YInt->t[nerv[i]][iDeb-j];

			for(j=iDeb+1; j<X[i]->lig; j++) Y[i]->t[j][0] = YExt->t[nerv[i]][j-iDeb];

			for(j=0; j<=iDeb; j++)			Z[i]->t[j][0] = ZInt->t[nerv[i]][iDeb-j];

			for(j=iDeb+1; j<X[i]->lig; j++) Z[i]->t[j][0] = ZExt->t[nerv[i]][j-iDeb];

			for(j=0; j<=iDeb; j++)			P[i]->t[j][0] = xIntProf->t[iDeb-j][0];

			for(j=iDeb+1; j<X[i]->lig; j++) P[i]->t[j][0] = xExtProf->t[j-iDeb][0];

		}

		else //debut et fin en intrados

		{

			if(Deb[i]>Fin[i]) //inversion Deb<->Fin

			{

				Ind(Fin[i],xIntProf,&iDeb,&iCol);

				Ind(Deb[i],xIntProf,&iFin,&iCol);

			}

			else

			{

				Ind(Deb[i],xIntProf,&iDeb,&iCol);

				Ind(Fin[i],xIntProf,&iFin,&iCol);

			}

			X[i] = CreerMatrice(iFin-iDeb+1, 1);

			Y[i] = CreerMatrice(iFin-iDeb+1, 1);

			Z[i] = CreerMatrice(iFin-iDeb+1, 1);

			P[i] = CreerMatrice(iFin-iDeb+1, 1);

			for(j=0; j<X[i]->lig; j++) X[i]->t[j][0] = XInt->t[nerv[i]][iDeb+j];

			for(j=0; j<Y[i]->lig; j++) Y[i]->t[j][0] = YInt->t[nerv[i]][iDeb+j];

			for(j=0; j<Z[i]->lig; j++) Z[i]->t[j][0] = ZInt->t[nerv[i]][iDeb+j];

			for(j=0; j<P[i]->lig; j++) P[i]->t[j][0] = xIntProf->t[iDeb+j][0];

		}

	}

	

	//interpolation d'un cote si nombre de points diffrent !

	if( X[0]->lig > X[1]->lig )

	{

		//tableau indice avant/aprs interpolation

		iAv=LinSpace(0.0f, (float)X[1]->lig-1, X[1]->lig);

		iAp=LinSpace(0.0f, (float)X[1]->lig-1, X[0]->lig);

		Res=CreerMatrice(X[0]->lig,1);

		InterpLinMat(iAv, X[1], iAp, Res); LibererMatrice(X[1]); X[1]=Res; 

		Res=CreerMatrice(X[0]->lig,1);

		InterpLinMat(iAv, Y[1], iAp, Res); LibererMatrice(Y[1]); Y[1]=Res; 

		Res=CreerMatrice(X[0]->lig,1);

		InterpLinMat(iAv, Z[1], iAp, Res); LibererMatrice(Z[1]); Z[1]=Res; 

		Res=CreerMatrice(X[0]->lig,1);

		InterpLinMat(iAv, P[1], iAp, Res); LibererMatrice(P[1]); P[1]=Res;

		LibererMatrice(iAv); LibererMatrice(iAp);

	}

	else if ( X[1]->lig > X[0]->lig )

	{

		//tableau indice avant/aprs interpolation

		iAv=LinSpace(0.0f, (float)X[0]->lig-1, X[0]->lig);

		iAp=LinSpace(0.0f, (float)X[0]->lig-1, X[1]->lig);

		Res=CreerMatrice(X[1]->lig,1);

		InterpLinMat(iAv, X[0], iAp, Res); LibererMatrice(X[0]); X[0]=Res; 

		Res=CreerMatrice(X[1]->lig,1);

		InterpLinMat(iAv, Y[0], iAp, Res); LibererMatrice(Y[0]); Y[0]=Res; 

		Res=CreerMatrice(X[1]->lig,1);

		InterpLinMat(iAv, Z[0], iAp, Res); LibererMatrice(Z[0]); Z[0]=Res; 

		Res=CreerMatrice(X[1]->lig,1);

		InterpLinMat(iAv, P[0], iAp, Res); LibererMatrice(P[0]); P[0]=Res; 

		LibererMatrice(iAv); LibererMatrice(iAp);

	}



	//inverse signe des X si nervure symtrique ...

	for(i=0; i<2; i++){

		if(symetrique[i]==true){

			for(j=0; j<X[i]->lig; j++) X[i]->t[j][0] *= -1.0f;}}

	

	//calcul du developp !!!

	CalculDeveloppe(

		X[0], Y[0], Z[0], X[1], Y[1], Z[1],

		&Xd[0], &Yd[0], &Xd[1], &Yd[1]);



	//init tableau pour calcul des pinces !!!

	newXd[0] = CreerMatrice(Xd[0]->lig, 1); newYd[0] = CreerMatrice(Xd[0]->lig, 1);

	newXd[1] = CreerMatrice(Xd[1]->lig, 1); newYd[1] = CreerMatrice(Xd[1]->lig, 1);

	for(i=0; i<Xd[0]->lig; i++)

	{

		newXd[0]->t[i][0]=Xd[0]->t[i][0]; newXd[1]->t[i][0]=Xd[1]->t[i][0]; 

		newYd[0]->t[i][0]=Yd[0]->t[i][0]; newYd[1]->t[i][0]=Yd[1]->t[i][0]; 

	}

	longCote[0] = Longueur(Xd[0],Yd[0]); //calcul longueur developpee cote 0

	longCote[1] = Longueur(Xd[1],Yd[1]); //calcul longueur developpee cote 1



	//calcul des pinces en BA cot 0 et 1

	for(n=0; n<2; n++)

	{

		//init indices pour cot 0 ou 1

		if(n==0){i0=0;i1=1;} else {i0=1; i1=0;}

		if(PosPinceBA[i0] > 0.0f) 

		{

			longCoteMax = longCote[i0]->t[longCote[i0]->lig-1][0];

			longPince = PosPinceBA[i0]*longCoteMax/100.0f;

			Ind( longPince , longCote[i0], &iPince, &iBidon);

			larg = sqrt(sqr(Xd[i0]->t[0][0]-Xd[i1]->t[0][0])+sqr(Yd[i0]->t[0][0]-Yd[i1]->t[0][0]));

			ampPince = AmpPinceBA[i0]*larg/100.0f;

			for(i=0; i<iPince; i++)

			{

				amp = ampPince*pow(1.0f - longCote[i0]->t[i][0]/longPince,modePinces);

				larg = sqrt(sqr(Xd[i0]->t[i][0]-Xd[i1]->t[i][0])+sqr(Yd[i0]->t[i][0]-Yd[i1]->t[i][0]));

				newXd[i0]->t[i][0] = Xd[i0]->t[i][0] + (Xd[i1]->t[i][0] - Xd[i0]->t[i][0]) * amp/larg;

				newYd[i0]->t[i][0] = Yd[i0]->t[i][0] + (Yd[i1]->t[i][0] - Yd[i0]->t[i][0]) * amp/larg;

			}

		}

	}

	//calcul des pinces en BF cot 0 et 1

	for(n=0; n<2; n++)

	{

		//init indices pour cot 0 ou 1

		if(n==0){i0=0;i1=1;} else {i0=1; i1=0;}

		if(PosPinceBF[i0] > 0.0f) 

		{

			longCoteMax = longCote[i0]->t[longCote[i0]->lig-1][0];

			longPince = PosPinceBF[i0]*longCoteMax/100.0f;

			Ind( longCoteMax - longPince , longCote[i0], &iPince, &iBidon);

			larg = sqrt(sqr(Xd[i0]->t[0][0]-Xd[i1]->t[0][0])+sqr(Yd[i0]->t[0][0]-Yd[i1]->t[0][0]));

			ampPince = AmpPinceBF[i0]*larg/100.0f;

			for(i=iPince; i<Xd[i0]->lig; i++)

			{

				amp = ampPince*pow(1.0f - (longCoteMax - longCote[i0]->t[i][0])/longPince, modePinces);

				larg = sqrt(sqr(Xd[i0]->t[i][0]-Xd[i1]->t[i][0])+sqr(Yd[i0]->t[i][0]-Yd[i1]->t[i][0]));

				newXd[i0]->t[i][0] = Xd[i0]->t[i][0] + (Xd[i1]->t[i][0] - Xd[i0]->t[i][0]) * amp/larg;

				newYd[i0]->t[i][0] = Yd[i0]->t[i][0] + (Yd[i1]->t[i][0] - Yd[i0]->t[i][0]) * amp/larg;

			}

		}

	}



	/*

	//ajout courbe des pinces pour test visuel !!!

	for(i=0; i<2; i++)

	{

		//courbes des 2 cots

		CourbPince[i] = CreerCourbe();

		CourbPince[i]->points = OFF;

		CourbPince[i]->symX = OFF;

		CourbPince[i]->pts = CreerMatrice(newXd[i]->lig, 2);

		//recopie points du developp dans la courbe

		for (j=0; j<newXd[i]->lig; j++)

		{

			CourbPince[i]->pts->t[j][0] = newXd[i]->t[j][0];

			CourbPince[i]->pts->t[j][1] = newYd[i]->t[j][0];

		}

		CourbPince[i]->points = ON;

		AjoutCourbe(AxePatron, CourbPince[i]);

	}

	*/



	//recopie cote avec pince -> cote

	LibererMatrice(Xd[0]); LibererMatrice(Xd[1]); 

	LibererMatrice(Yd[0]); LibererMatrice(Yd[1]); 

	Xd[0]=newXd[0]; Xd[1]=newXd[1]; Yd[0]=newYd[0]; Yd[1]=newYd[1]; 



	//creation des courbes des 2 cots + marges

	for(i=0; i<2; i++)

	{

		//courbes des 2 cots

		CourbPatron[i] = CreerCourbe();

		CourbPatron[i]->points = OFF;

		CourbPatron[i]->symX = OFF;

		CourbPatron[i]->pts = CreerMatrice(Xd[i]->lig, 2);

		//calcul des pinces du developp !!!



		//recopie points du developp dans la courbe

		for (j=0; j<Xd[i]->lig; j++)

		{

			CourbPatron[i]->pts->t[j][0] = Xd[i]->t[j][0];

			CourbPatron[i]->pts->t[j][1] = Yd[i]->t[j][0];

		}

		AjoutCourbe(AxePatron, CourbPatron[i]);



		//marges des 2 cots

		distance = Ones(CourbPatron[i]->pts->lig, 1);

		for(j=0; j<distance->lig; j++) distance->t[j][0]*=Marge[i]/100.0f;

		CourbMarge[i] = CreerCourbe();

		if(i==0)

			CourbMarge[i]->pts = CalculContour(CourbPatron[i]->pts, distance, -1);

		else

			CourbMarge[i]->pts = CalculContour(CourbPatron[i]->pts, distance, +1);

		CourbMarge[i]->points = OFF; CourbMarge[i]->symX = OFF;

		AjoutCourbe(AxePatron, CourbMarge[i]);

		LibererMatrice(distance);

	}



	//cot et marge avant

	if((Xd[0]->t[0][0]!=Xd[1]->t[0][0]) //test points Av cote 1&2 confondus

		||(Yd[0]->t[0][0]!=Yd[1]->t[0][0]))

	{

		//cot avant

		CourbAv = CreerCourbe();

		CourbAv->pts = CreerMatrice(2,2);

		CourbAv->pts->t[0][0] = Xd[0]->t[0][0];

		CourbAv->pts->t[1][0] = Xd[1]->t[0][0];

		CourbAv->pts->t[0][1] = Yd[0]->t[0][0];

		CourbAv->pts->t[1][1] = Yd[1]->t[0][0];

		CourbAv->points = OFF; CourbAv->symX = OFF;

		AjoutCourbe(AxePatron, CourbAv);

		

		//marge avant

		distance = Ones(2, 1);

		for(j=0; j<distance->lig; j++) distance->t[j][0]*=MargeDeb/100.0f;

		CourbMargeAv = CreerCourbe();

		CourbMargeAv->pts = CalculContour(CourbAv->pts, distance, +1);

		CourbMargeAv->points = OFF; CourbMargeAv->symX = OFF;

		AjoutCourbe(AxePatron, CourbMargeAv);

		LibererMatrice(distance);

		

		//ajout coin des marges cot 1&2

		for(i=0; i<2; i++)

		{

			CourbCoin=CreerCourbe();

			CourbCoin->points = OFF;

			CourbCoin->pts = Zeros(3,2);

			CourbCoin->pts->t[0][0] = CourbMarge[i]->pts->t[0][0];

			CourbCoin->pts->t[0][1] = CourbMarge[i]->pts->t[0][1];

			CourbCoin->pts->t[2][0] = CourbMargeAv->pts->t[0][0];

			CourbCoin->pts->t[2][1] = CourbMargeAv->pts->t[0][1];

			Inter2Vecteurs(

				CourbMarge[i]->pts->t[1][0], CourbMarge[i]->pts->t[1][1],

				CourbMarge[i]->pts->t[0][0], CourbMarge[i]->pts->t[0][1],

				CourbMargeAv->pts->t[1][0], CourbMargeAv->pts->t[1][1],

				CourbMargeAv->pts->t[0][0], CourbMargeAv->pts->t[0][1],

				&(CourbCoin->pts->t[1][0]), &(CourbCoin->pts->t[1][1]));

			AjoutCourbe(AxePatron, CourbCoin);

		}

	}

	else //relie les marges cote 1&2 par un segment

	{

		CourbAv = CreerCourbe(); CourbAv->points = OFF;

		CourbAv->pts = Zeros(2,2);

		CourbAv->pts->t[0][0]=CourbMarge[0]->pts->t[0][0];

		CourbAv->pts->t[0][1]=CourbMarge[0]->pts->t[0][1];

		CourbAv->pts->t[1][0]=CourbMarge[1]->pts->t[0][0];

		CourbAv->pts->t[1][1]=CourbMarge[1]->pts->t[0][1];

		AjoutCourbe(AxePatron, CourbAv);

	}



	//cot et marge arrire

	n=Xd[0]->lig-1;

	if((Xd[0]->t[n][0]!=Xd[1]->t[n][0]) //test points Ar cote 1&2 confondus

		||(Yd[0]->t[n][0]!=Yd[1]->t[n][0]))

	{

		//cot arrire

		CourbAr = CreerCourbe();

		CourbAr->pts = CreerMatrice(2,2);

		CourbAr->pts->t[0][0] = Xd[0]->t[n][0];

		CourbAr->pts->t[1][0] = Xd[1]->t[n][0];

		CourbAr->pts->t[0][1] = Yd[0]->t[n][0];

		CourbAr->pts->t[1][1] = Yd[1]->t[n][0];

		CourbAr->points = OFF; CourbAr->symX = OFF;

		AjoutCourbe(AxePatron, CourbAr);

		

		//marge arrire

		distance = Ones(2, 1);

		for(j=0; j<distance->lig; j++) distance->t[j][0]*=MargeFin/100.0f;

		CourbMargeAr = CreerCourbe();

		CourbMargeAr->pts = CalculContour(CourbAr->pts, distance, -1);

		CourbMargeAr->points = OFF; CourbMargeAr->symX = OFF;

		AjoutCourbe(AxePatron, CourbMargeAr);

		LibererMatrice(distance);



		//ajout coin des marges cot 1&2

		for(i=0; i<2; i++)

		{

			//ajout coin des marges Ar/cot 1

			CourbCoin=CreerCourbe();

			CourbCoin->points = OFF;

			CourbCoin->pts = Zeros(3,2);

			n=CourbMarge[i]->pts->lig-1;

			CourbCoin->pts->t[0][0] = CourbMarge[i]->pts->t[n][0];

			CourbCoin->pts->t[0][1] = CourbMarge[i]->pts->t[n][1];

			CourbCoin->pts->t[2][0] = CourbMargeAr->pts->t[0][0];

			CourbCoin->pts->t[2][1] = CourbMargeAr->pts->t[0][1];

			Inter2Vecteurs(

				CourbMarge[i]->pts->t[n][0], CourbMarge[i]->pts->t[n][1],

				CourbMarge[i]->pts->t[n-1][0], CourbMarge[i]->pts->t[n-1][1],

				CourbMargeAr->pts->t[1][0], CourbMargeAr->pts->t[1][1],

				CourbMargeAr->pts->t[0][0], CourbMargeAr->pts->t[0][1],

				&(CourbCoin->pts->t[1][0]), &(CourbCoin->pts->t[1][1]));

			AjoutCourbe(AxePatron, CourbCoin);

		}

	}

	else //relie les marges cote 1&2 par un segment

	{

		CourbAr = CreerCourbe(); CourbAr->points = OFF;

		CourbAr->pts = Zeros(2,2);

		CourbAr->pts->t[0][0]=CourbMarge[0]->pts->t[n][0];

		CourbAr->pts->t[0][1]=CourbMarge[0]->pts->t[n][1];

		CourbAr->pts->t[1][0]=CourbMarge[1]->pts->t[n][0];

		CourbAr->pts->t[1][1]=CourbMarge[1]->pts->t[n][1];

		AjoutCourbe(AxePatron, CourbAr);

	}

	

	//ajout des repres de suspente

	for(i=0 ;i<2; i++) //boucle cot

	{

		//creation matrices intermediaires pour interpolation points de suspentage

		interpXSuspente = Zeros(P[i]->lig,2);

		interpYSuspente = Zeros(P[i]->lig,2);

		for (j=0; j<P[i]->lig; j++)

		{

			interpXSuspente->t[j][0]=P[i]->t[j][0];

			interpYSuspente->t[j][0]=P[i]->t[j][0];

		}

		for (j=0; j<P[i]->lig; j++)

		{

			interpXSuspente->t[j][1]=Xd[i]->t[j][0];

			interpYSuspente->t[j][1]=Yd[i]->t[j][0];

		}

		

		//boucle 4 lignes de suspentes

		for(j=0; j<4; j++)

		{

			//init par defaut a (-1,-1) -> pas de repere !

			xSuspente[i][j]=-1.0f; ySuspente[i][j]=-1.0f;

			//test point de suspentage sur le patron ?

			posSuspente = F->TabForme->t[nerv[i]][8+j];

			if( (posSuspente >= P[i]->t[0][0]) || (posSuspente <= P[i]->t[P[i]->lig-1][0]) )

			{

				//interpolation X et Y point de suspentage courant (cote i, range j)

				xSuspente[i][j] = InterpLinX(interpXSuspente, F->TabForme->t[nerv[i]][8+j]);

				ySuspente[i][j] = InterpLinX(interpYSuspente, F->TabForme->t[nerv[i]][8+j]);

				//ajout croix au graphe

				if(ReperesSuspentes[i]==1)

				//test fait a ce niveau pour avoir coordonnes pts suspentes

				//pour le calcul des cercles de ventilation

				{

					CourbRep = CreerCourbe(); CourbRep->points = OFF;

					CourbRep->pts = Zeros(2,2);

					CourbRep->pts->t[0][0]=xSuspente[i][j]-0.01f;

					CourbRep->pts->t[0][1]=ySuspente[i][j]-0.01f;

					CourbRep->pts->t[1][0]=xSuspente[i][j]+0.01f;

					CourbRep->pts->t[1][1]=ySuspente[i][j]+0.01f;

					AjoutCourbe(AxePatron, CourbRep);

					CourbRep = CreerCourbe(); CourbRep->points = OFF;

					CourbRep->pts = Zeros(2,2);

					CourbRep->pts->t[0][0]=xSuspente[i][j]-0.01f;

					CourbRep->pts->t[0][1]=ySuspente[i][j]+0.01f;

					CourbRep->pts->t[1][0]=xSuspente[i][j]+0.01f;

					CourbRep->pts->t[1][1]=ySuspente[i][j]-0.01f;

					AjoutCourbe(AxePatron, CourbRep);

				}

			}

		}

		//liberation matrices intermedaires

		LibererMatrice(interpXSuspente); LibererMatrice(interpYSuspente); 

	}



	//ajout cercles de ventilation

	if(Ventilation==1)

	{

		for(i=1; i<4; i++)

		{

			//test 2 point de suspentage consecutif, des 2 cots, sur le patron

			if((xSuspente[0][i]!=-1.0f)

				&&(xSuspente[1][i]!=-1.0f)

				&&(xSuspente[0][i-1]!=-1.0f)

				&&(xSuspente[1][i-1]!=-1.0f))

			{

					CourbCercle = CreerCourbe();

					CourbCercle->points = OFF;

					CourbCercle->pts = Cercle(

						(xSuspente[0][i]+xSuspente[1][i]+xSuspente[0][i-1]+xSuspente[1][i-1])/4.0,

						(ySuspente[0][i]+ySuspente[1][i]+ySuspente[0][i-1]+ySuspente[1][i-1])/4.0,

						(ySuspente[0][i]+ySuspente[0][i-1]-ySuspente[1][i]-ySuspente[1][i-1])/8.0,

						36);	

					AjoutCourbe(AxePatron, CourbCercle);

			}

		}

	}



	// ajout texte !!!

	if(Numerotation==1)

	{

		xText = (Xd[0]->t[0][0] + Xd[0]->t[Xd[0]->lig-1][0]

			+Xd[1]->t[0][0] + Xd[1]->t[Xd[1]->lig-1][0])/4.0f;

		yText = (Yd[0]->t[0][0] + Yd[0]->t[Yd[0]->lig-1][0]

			+Yd[1]->t[0][0] + Yd[1]->t[Yd[1]->lig-1][0])/4.0f;

		sprintf(texte, "%d%c%03.1f%c%03.1f_%d%c%03.1f%c%03.1f",

			NoNerv[0],texteExtInt[FaceDeb[0]-1],Deb[0],texteExtInt[FaceFin[0]-1],Fin[0],

			NoNerv[1],texteExtInt[FaceDeb[1]-1],Deb[1],texteExtInt[FaceFin[1]-1],Fin[1]);

		AjoutTexte(AxePatron,texte, 0.02f, 0.0f, xText-0.2f, yText);

	}

	

	//ajout d'une courbe bidon pour le zoom 

	CourbZoom = CreerCourbe();

	CourbZoom->pts = Zeros(5,2);

	CourbZoom->points = OFF;

	CourbZoom->segments = OFF;

	CourbZoom->symX = OFF;

	CourbZoom->CouleurSegments[0]=0.0f;

	CourbZoom->CouleurSegments[2]=0.0f;

	AjoutCourbe(AxePatron, CourbZoom);



	//creation Mesh pour visualisation 3d du patron

	MeshPatron=CreerMesh();

	MeshPatron->InvNormales=OFF;

	MeshPatron->segments=OFF; MeshPatron->faces=ON;

	MeshPatron->x=CreerMatrice(X[0]->lig, 2);

	MeshPatron->y=CreerMatrice(X[0]->lig, 2);

	MeshPatron->z=CreerMatrice(X[0]->lig, 2);

	for(i=0; i<X[0]->lig; i++)

	{

		MeshPatron->x->t[i][0] = X[0]->t[i][0];

		MeshPatron->x->t[i][1] = X[1]->t[i][0];

		MeshPatron->y->t[i][0] = Y[0]->t[i][0];

		MeshPatron->y->t[i][1] = Y[1]->t[i][0];

		MeshPatron->z->t[i][0] = Z[0]->t[i][0];

		MeshPatron->z->t[i][1] = Z[1]->t[i][0];

	}

	AjoutMesh(Axe3d, MeshPatron);

	

	//definition eclairage

	Axe3d->eclairage = ON;



	//liberation matrice pour patron

	for(i=0; i<2; i++){

		LibererMatrice(X[i]); LibererMatrice(Y[i]);

		LibererMatrice(Z[i]); LibererMatrice(P[i]);

		LibererMatrice(Xd[i]); LibererMatrice(Yd[i]);}





	////////////////////////////////////////////////////////////////



	//liberation matrices intermediaires !!!

	LibererMatrice(XExt); LibererMatrice(YExt); LibererMatrice(ZExt);

	LibererMatrice(XInt); LibererMatrice(YInt); LibererMatrice(ZInt);

}





/****************/

/* display      */

/****************/

void display(void)
{
	//CalculVue3dEtPatron();

	VisuAxe(Axe3d);

	glutSwapBuffers();

	VisuAxe(AxePatron);

	glutSwapBuffers();

}


/*****************/

/* reshape       */

/*****************/

void reshape(int w, int h)
{
	glViewport(0, 0, w, h);

	display();

}



/*****************/

/* motion        */

/*****************/

void motion(int x, int y)

{

	//pour gestion zoom dans fenetre patron

	float xs,ys; /*coordonnes souris dans l'axe*/

	float xmin,xmax,ymin,ymax; /*min max de l'axe selectionn*/

	int h,w; /*taille de la fenetre*/

	float dx, dy; //pour zoom OUT



	/*message pour test*/

	//printf("\n<%d,%d>",x,y);

	

	/*axe 3d -> rotation*/

	if (Rotation3d)

	{

		Axe3d->azimuth = Axe3d->azimuth + (x - xSouris);

		Axe3d->incidence = Axe3d->incidence + (y - ySouris);

		xSouris = x; ySouris = y;

	}

	

	/*axe 3d -> translation*/

	else if (Translation3d)

	{

		Axe3d->xcam = Axe3d->xcam + (float)(x - xSouris)/100.0;

		Axe3d->ycam = Axe3d->ycam - (float)(y - ySouris)/100.0;

		xSouris = x; ySouris = y;

	}

	

	/*axe 3d -> zoom*/

	else if (ZoomTwist3d)

	{

		Axe3d->twist = Axe3d->twist - (float)(x - xSouris);

		Axe3d->zcam = Axe3d->zcam + (float)(y - ySouris)/100.0;

		xSouris = x; ySouris = y;

	}



	/*axe patron  -> zoom IN*/

	else if (zoomIN)

	{

		/*conversion en coordonnes repere des coordonnes souris*/

		w = glutGet(GLUT_WINDOW_WIDTH);

		h = glutGet(GLUT_WINDOW_HEIGHT);

		xmin=AxeSel->xmin; xmax=AxeSel->xmax;

		ymin=AxeSel->ymin; ymax=AxeSel->ymax;

		xs=xmin+(float)x*(xmax-xmin)/(float)w;

		ys=ymin+((float)h-(float)y)*(ymax-ymin)/h;



		/*si debut du zoom, init cadre*/

		if(debZoomIN)

		{

			debZoomIN=false;

			CourbZoom->pts->t[0][0]=xs; CourbZoom->pts->t[0][1]=ys;

			CourbZoom->pts->t[4][0]=xs; CourbZoom->pts->t[4][1]=ys;

			CourbZoom->pts->t[3][0]=xs;	CourbZoom->pts->t[1][1]=ys;

		}



		/*mise a jour position cadre*/

		CourbZoom->pts->t[1][0]=xs; CourbZoom->pts->t[3][1]=ys;

		CourbZoom->pts->t[2][0]=xs; CourbZoom->pts->t[2][1]=ys;

	}



	/*si fin du zoom, init position axe*/

	else if(finZoomIN)

	{

		finZoomIN=false;

		//test points non confondus

		if ((CourbZoom->pts->t[0][0] != CourbZoom->pts->t[2][0])

			&&(CourbZoom->pts->t[0][1] != CourbZoom->pts->t[2][1]))

		{

			//assure xmin<xmax

			if(CourbZoom->pts->t[0][0] < CourbZoom->pts->t[2][0]){

				AxePatron->xmin = CourbZoom->pts->t[0][0];

				AxePatron->xmax = CourbZoom->pts->t[2][0];}

			else{

				AxePatron->xmax = CourbZoom->pts->t[0][0];

				AxePatron->xmin = CourbZoom->pts->t[2][0];}

			//assure ymin<ymax

			if(CourbZoom->pts->t[0][1] < CourbZoom->pts->t[2][1]){

				AxePatron->ymin = CourbZoom->pts->t[0][1];

				AxePatron->ymax = CourbZoom->pts->t[2][1];}

			else{

				AxePatron->ymax = CourbZoom->pts->t[0][1];

				AxePatron->ymin = CourbZoom->pts->t[2][1];}

		}

	}	

	

	/*si quitter zoom , "dzoomer" autour du point selectionn !!!*/

	else if(zoomOUT)

	{

		/*conversion en coordonnes repere des coordonnes souris*/

		w = glutGet(GLUT_WINDOW_WIDTH);

		h = glutGet(GLUT_WINDOW_HEIGHT);

		xmin=AxeSel->xmin; xmax=AxeSel->xmax;

		ymin=AxeSel->ymin; ymax=AxeSel->ymax;

		xs=xmin+(float)x*(xmax-xmin)/(float)w;

		ys=ymin+((float)h-(float)y)*(ymax-ymin)/h;



		/*dzoom x2*/

		zoomOUT=false;

		dx = AxePatron->xmax - AxePatron->xmin;

		dy = AxePatron->ymax - AxePatron->ymin;

		AxePatron->xmin = xs-dx; AxePatron->xmax = xs+dx;

		AxePatron->ymin = ys-dy; AxePatron->ymax = ys+dy;

	}

	

	/*affichage*/

	//printf("\nx=%d, y=%d, xs=%f, ys=%f, dist=%f       ",x,y,xs,ys,distmin);

	

	glutPostRedisplay();

}



/****************/

/* BoutonSouris */

/****************/

void BoutonSouris(int button, int state, int x, int y)

{

	int Fenetre;

	//float xmil, ymil; //pour zoom OUT

	

	/*memorise position de la souris dans la fenetre*/

	xSouris =x; ySouris = y;

	

	/*par defaut pas de point ni d'axe selectionn 

	et pas de rotation/translation/zoom 3d

	et ne pas redessinner tous les axes*/

	AxeSel = NULL;

	/*Rotation3d = OFF;

	Translation3d = OFF;

	ZoomTwist3d = OFF;*/

	

	/*recupere axe correspondant  la fenetre courante*/

	Fenetre = glutGetWindow();

	if (Fenetre == Fenetre3d) {AxeSel=Axe3d; /*printf("Axe3d ->");*/}

	if (Fenetre == FenetrePatron) {AxeSel=AxePatron; /*printf("Axe3d ->");*/}

	

	/*test debut/fin, rotation/translation/zoom pour Axe3d*/

	if (AxeSel == Axe3d)

	{

		if (state == GLUT_DOWN)

		{

			switch(button)

			{

			case GLUT_LEFT_BUTTON :

				if (Translation3d == ON) {Translation3d = OFF; ZoomTwist3d = ON;}

				else Rotation3d = ON;

				break;

			case GLUT_RIGHT_BUTTON :

				if (Rotation3d == ON) {Rotation3d = OFF; ZoomTwist3d = ON;}

				else Translation3d = ON;

				break;

			case GLUT_MIDDLE_BUTTON :

				ZoomTwist3d = ON;

				break;

			default: printf("\n type de bouton souris inconnu !!!");

			}

		}

		else /*state = GLUT_UP*/

		{

			finZoomIN = true;

			Rotation3d = OFF;

			Translation3d = OFF;

			ZoomTwist3d = OFF;

		}

	}	



	/*test debut/fin zoomIN, zoomOUT, retour Axe Automatique pour Axe3d*/

	if (AxeSel == AxePatron)

	{

		if (state == GLUT_DOWN)

		{

			switch(button)

			{

			case GLUT_LEFT_BUTTON : //zoomIN

				//test 2 boutons enfoncs !!!

				if(zoomOUT) {quitZoom=true; break;}

				//test si debut de zoom

				if(!zoomIN) {zoomIN=true, debZoomIN=true;}

				CourbZoom->segments = ON;

				AxePatron->XAuto = OFF; AxePatron->YAuto = OFF; AxePatron->ZAuto = OFF; 

				break;

			case GLUT_RIGHT_BUTTON : //zoomOUT x2

				//test 2 boutons enfoncs !!!

				if(zoomIN) {quitZoom=true; break;}

				zoomOUT = true;

				AxePatron->XAuto = OFF; AxePatron->YAuto = OFF; AxePatron->ZAuto = OFF; 

				break;

			case GLUT_MIDDLE_BUTTON :

				quitZoom=true;

				break;

			default: printf("\n type de bouton souris inconnu !!!");

			}

		}

		else /*state = GLUT_UP*/

		{

			if(zoomIN)

			{

				zoomIN = false;

				finZoomIN = true;

				CourbZoom->segments = OFF;

				motion(x,y); //appel a motion pour maj axe

			}

			else if(zoomOUT)

			{

				motion(x,y); //appel a motion pour maj axe

			}

			else if(quitZoom)

			{

				quitZoom=false;	zoomIN=false; debZoomIN=false; finZoomIN=false;	zoomOUT=false;

				AxePatron->XAuto = ON; AxePatron->YAuto = ON; AxePatron->ZAuto = ON; 

			}

			glutPostRedisplay();

		}

	}	

}



/*****************/

/* keyboard      */

/*****************/

void keyboard(unsigned char key, int x, int y)

{

	switch (key)

	{

	case 27: Quitter(0); break;

	default:;

	}

}



/*****************/

/* InitFenetre   */

/*****************/

void InitFenetre(void)

{

	glEnable(GL_LINE_STIPPLE);

	glutDisplayFunc(display);

	glutReshapeFunc(reshape);

	glutKeyboardFunc (keyboard);

	glutMotionFunc(motion);

	glutMouseFunc(BoutonSouris);

}



/*****************/

/* InitLumiere   */

/*****************/

void InitLumiere(void)

{

	float mat_specular[]={1.0, 1.0, 1.0, 1.0};

	float mat_shininess[]={50.0};

	float light_position[]={0.0, 0.0, 1.0, 0.0};

	float light_color[]={1.0, 1.0, 0.0, 1.0};

	

	glShadeModel(GL_SMOOTH);

	/*glClearColor(0.0, 0.0, 0.0, 0.0);*/

	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);

	glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);

	

	glLightfv(GL_LIGHT0, GL_POSITION, light_position);

	glLightfv(GL_LIGHT0, GL_DIFFUSE, light_color);

	glLightfv(GL_LIGHT0, GL_SPECULAR, light_color);

	

	glEnable(GL_LIGHTING);

	glEnable(GL_LIGHT0);

	glEnable(GL_DEPTH_TEST);

	glEnable(GL_NORMALIZE);

}



/*****************/

/* M A I N       */

/*****************/

int main(int argc, char** argv)
{

	//int i;

	int ws, hs;

	float EpaiRelProfCent, EpaiRelProfBout;



	/*message*/

	printf("\nWindPatterns ");

	printf(AUTEUR_DATE);

	printf("\n");



	/*init glut*/
	glutInit(&argc, argv);
	glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowSize (500, 500);
	glutInitWindowPosition (100, 100);

	

	/* creation fenetre/axe/courbes Axe3d*/

	Fenetre3d=glutCreateWindow ("Visualisation 3D");

	InitFenetre(); InitLumiere();

	Axe3d=CreerAxe(Fenetre3d); Axe3d->axe3d=ON;



	/* creation fenetre/axe/courbes AxePatron*/

	FenetrePatron=glutCreateWindow ("Patron");

	InitFenetre(); //InitLumiere();

	AxePatron=CreerAxe(FenetrePatron);

	

	/*recupere taille de l'ecran en pixel*/

	ws = glutGet( GLUT_SCREEN_WIDTH );

	hs = glutGet( GLUT_SCREEN_HEIGHT );

	

	/*redefini taille et position des fenetre 3D*/

	glutSetWindow( Fenetre3d );

	glutPositionWindow((int)(0.70*(float)ws), (int)(0.05*(float)hs));

	glutReshapeWindow((int)(0.30*(float)ws), (int)(0.40*(float)hs));



	/*redefini taille et position des fenetre Patron*/

	glutSetWindow( FenetrePatron );

	glutPositionWindow((int)(0.0*(float)ws), (int)(0.50*(float)hs));

	glutReshapeWindow((int)(1.0*(float)ws), (int)(0.45*(float)hs));

	

	//lecture fichier de forme

	strcpy(NomFichierForme,"FormeDefaut.txt");

	F = LectureFichierForme(NomFichierForme);

	

	//chargement profils

	LectureFichierProfil(F->NomProfilCent, &ExtProfCent, &IntProfCent);

	LectureFichierProfil(F->NomProfilBout, &ExtProfBout, &IntProfBout);



	//calcul epaisseur relative ?

	EpaiRelProfCent=EpaisseurRelative(ExtProfCent, IntProfCent);

	EpaiRelProfBout=EpaisseurRelative(ExtProfBout, IntProfBout);



	//applique distribution des x du profil du bout comme au centre

	InterpoleProfilBout(&ExtProfBout, ExtProfCent);

	InterpoleProfilBout(&IntProfBout, IntProfCent);

	

	/****************************************/

	/*         Here's the GLUI code         */

	/****************************************/

	

	/*affichage No de version et creation fenetre*/

	printf( "Ce programme utilise GLUI version: %3.2f\n", GLUI_Master.get_version() );

	glui = GLUI_Master.create_glui( "Boite de dialogue",0,0,0);

	

	/*cote 1*/

	/*No Nerv 1*/

	SpinNoNerv[0] =	glui->add_spinner("No Nerv 1", GLUI_SPINNER_INT, &(NoNerv[0]));

	SpinNoNerv[0] -> set_int_limits( -1, F->TabForme->lig-1 );

	/*% Deb 1*/

	GLUI_Panel *panel_Deb1 = glui->add_panel("");//, GLUI_PANEL_NONE);

	GLUI_Spinner *SpinDeb1 = glui->add_spinner_to_panel(

		panel_Deb1,"% Deb 1", GLUI_SPINNER_FLOAT, &(Deb[0]));

	SpinDeb1 -> set_float_limits( 0.0, 100.0 );

	GLUI_Listbox *ListDeb1 = glui->add_listbox_to_panel(panel_Deb1,"Face",&FaceDeb[0]);

	ListDeb1->add_item( 1, "Ext" ); ListDeb1->add_item( 2, "Int" );

	/*% Deb 1*/

	GLUI_Panel *panel_Fin1 = glui->add_panel("");//, GLUI_PANEL_NONE);

	GLUI_Spinner *SpinFin1 = glui->add_spinner_to_panel(

		panel_Fin1,"% Fin 1", GLUI_SPINNER_FLOAT, &(Fin[0]));

	SpinFin1 -> set_float_limits( 0.0, 100.0 );

	GLUI_Listbox *ListFin1 = glui->add_listbox_to_panel(panel_Fin1,"Face",&FaceFin[0]);

	ListFin1->add_item( 1, "Ext" ); ListFin1->add_item( 2, "Int" );

	/*Reperes 1*/

/*

	GLUI_Panel *panel_Rep1 = glui->add_panel("");//, GLUI_PANEL_NONE);

	GLUI_Spinner *SpinPosRep1 = glui->add_spinner_to_panel(

		panel_Rep1,"% Rep", GLUI_SPINNER_FLOAT, &(PosRep[0]));

	SpinPosRep1 -> set_float_limits( 0.0, 100.0 );

	GLUI_Listbox *ListRep1 = glui->add_listbox_to_panel(panel_Rep1,"Face",&FaceRep[0]);

	ListRep1->add_item( 1, "Ext" ); ListRep1->add_item( 2, "Int" );

	glui->add_button_to_panel(panel_Rep1, "Ajouter", 0, Ajouter );

*/

	/*Marge de couture en cm*/

	GLUI_Spinner *SpinMarge1 = glui->add_spinner(

		"Marge 1", GLUI_SPINNER_FLOAT, &(Marge[0]));

	SpinMarge1 -> set_float_limits( 0.0, 5.0 );



	/*reperes suspentes*/

	glui->add_checkbox("reperes suspentes",&(ReperesSuspentes[0]));



	/*panel pinces!!!*/

	GLUI_Panel *panel_Pince1 = glui->add_panel("Pinces 1");//, GLUI_PANEL_NONE);

	/*position debut pincement au BA en %*/

	GLUI_Spinner *SpinPosPinceBA1 = glui->add_spinner_to_panel(panel_Pince1,

		"Pos BA (%)", GLUI_SPINNER_FLOAT, &(PosPinceBA[0]));

	SpinPosPinceBA1 -> set_float_limits( 0.0, 40.0 );

	/*Amplitude pincement au BA en %*/

	GLUI_Spinner *SpinAmpPinceBA1 = glui->add_spinner_to_panel(panel_Pince1,

		"Amp BA (%)", GLUI_SPINNER_FLOAT, &(AmpPinceBA[0]));

	SpinAmpPinceBA1 -> set_float_limits( 0.0, 40.0 );

	/*position debut pincement au BF en %*/

	GLUI_Spinner *SpinPosPinceBF1 = glui->add_spinner_to_panel(panel_Pince1,

		"Pos BF (%)", GLUI_SPINNER_FLOAT, &(PosPinceBF[0]));

	SpinPosPinceBF1 -> set_float_limits( 0.0, 40.0 );

	/*Amplitude pincement au BF en %*/

	GLUI_Spinner *SpinAmpPinceBF1 = glui->add_spinner_to_panel(panel_Pince1,

		"Amp BF (%)", GLUI_SPINNER_FLOAT, &(AmpPinceBF[0]));

	SpinAmpPinceBF1 -> set_float_limits( 0.0, 40.0 );





	/*cote 2*/

	glui->add_column(true);

	/*No Nerv 2*/

	SpinNoNerv[1] = glui->add_spinner("No Nerv 2", GLUI_SPINNER_INT, &(NoNerv[1]));

	SpinNoNerv[1] -> set_int_limits( -1, F->TabForme->lig-1 );

	/*% Deb 2*/

	GLUI_Panel *panel_Deb2 = glui->add_panel("");//, GLUI_PANEL_NONE);

	GLUI_Spinner *SpinDeb2 = glui->add_spinner_to_panel(

		panel_Deb2,"% Deb 2", GLUI_SPINNER_FLOAT, &(Deb[1]));

	SpinDeb2 -> set_float_limits( 0.0, 100.0 );

	GLUI_Listbox *ListDeb2 = glui->add_listbox_to_panel(panel_Deb2,"Face",&FaceDeb[1]);

	ListDeb2->add_item( 1, "Ext" ); ListDeb2->add_item( 2, "Int" );

	/*% Deb 2*/

	GLUI_Panel *panel_Fin2 = glui->add_panel("");//, GLUI_PANEL_NONE);

	GLUI_Spinner *SpinFin2 = glui->add_spinner_to_panel(

		panel_Fin2,"% Fin 2", GLUI_SPINNER_FLOAT, &(Fin[1]));

	SpinFin2 -> set_float_limits( 0.0, 100.0 );

	GLUI_Listbox *ListFin2 = glui->add_listbox_to_panel(panel_Fin2,"Face",&FaceFin[1]);

	ListFin2->add_item( 1, "Ext" ); ListFin2->add_item( 2, "Int" );

	//ListFin2->set_int_val(1);

	/*Reperes 2*/

/*

	GLUI_Panel *panel_Rep2 = glui->add_panel("");//, GLUI_PANEL_NONE);

	GLUI_Spinner *SpinPosRep2 = glui->add_spinner_to_panel(

		panel_Rep2,"% Rep", GLUI_SPINNER_FLOAT, &(PosRep[1]));

	SpinPosRep2 -> set_float_limits( 0.0, 100.0 );

	GLUI_Listbox *ListRep2 = glui->add_listbox_to_panel(panel_Rep2,"Face",&FaceRep[1]);

	ListRep2->add_item( 1, "Ext" ); ListRep2->add_item( 2, "Int" );

	glui->add_button_to_panel(panel_Rep2, "Ajouter", 1, Ajouter );

*/

	/*Marge de couture en cm*/

	GLUI_Spinner *SpinMarge2 = glui->add_spinner(

		"Marge 2", GLUI_SPINNER_FLOAT, &(Marge[1]));

	SpinMarge2 -> set_float_limits( 0.0, 5.0 );



	/*reperes suspentes*/

	glui->add_checkbox("reperes suspentes",&(ReperesSuspentes[1]));



	/*panel pinces!!!*/

	GLUI_Panel *panel_Pince2 = glui->add_panel("Pinces 2");//, GLUI_PANEL_NONE);

	/*position debut pincement au BA en %*/

	GLUI_Spinner *SpinPosPinceBA2 = glui->add_spinner_to_panel(panel_Pince2,

		"Pos BA (%)", GLUI_SPINNER_FLOAT, &(PosPinceBA[1]));

	SpinPosPinceBA2 -> set_float_limits( 0.0, 40.0 );

	/*Amplitude pincement au BA en %*/

	GLUI_Spinner *SpinAmpPinceBA2 = glui->add_spinner_to_panel(panel_Pince2,

		"Amp BA (%)", GLUI_SPINNER_FLOAT, &(AmpPinceBA[1]));

	SpinAmpPinceBA2 -> set_float_limits( 0.0, 40.0 );

	/*position debut pincement au BF en %*/

	GLUI_Spinner *SpinPosPinceBF2 = glui->add_spinner_to_panel(panel_Pince2,

		"Pos BF (%)", GLUI_SPINNER_FLOAT, &(PosPinceBF[1]));

	SpinPosPinceBF2 -> set_float_limits( 0.0, 40.0 );

	/*Amplitude pincement au BF en %*/

	GLUI_Spinner *SpinAmpPinceBF2 = glui->add_spinner_to_panel(panel_Pince2,

		"Amp BF (%)", GLUI_SPINNER_FLOAT, &(AmpPinceBF[1]));

	SpinAmpPinceBF2 -> set_float_limits( 0.0, 40.0 );





	/*3eme colonne*/

	glui->add_column(true);

	/*Marge de couture Deb en cm*/

	GLUI_Spinner *SpinMargeDeb = glui->add_spinner(

		"Marge Deb", GLUI_SPINNER_FLOAT, &(MargeDeb));

	SpinMargeDeb -> set_float_limits( 0.0, 5.0 );

	/*Marge de couture Fin en cm*/

	GLUI_Spinner *SpinMargeFin = glui->add_spinner(

		"Marge Fin", GLUI_SPINNER_FLOAT, &(MargeFin));

	SpinMargeFin -> set_float_limits( 0.0, 5.0 );

	/*reperes de couture*/

/*

	glui->add_checkbox("reperes couture",&ReperesCoutures);

*/

	/*ventilation*/

	glui->add_checkbox("ventilation",&Ventilation);

	/*numerotation*/

	glui->add_checkbox("numerotation",&Numerotation);



	/*mode de pincement des pinces !*/

	GLUI_Spinner *SpinModePinces = glui->add_spinner(

		"mode pinces", GLUI_SPINNER_FLOAT, &(modePinces));

	SpinModePinces -> set_float_limits( 1.0, 3.0 );



	/*nom fichier forme*/

	GLUI_Panel *panel_forme = glui->add_panel("", GLUI_PANEL_EMBOSSED);

	FicForme = glui->add_statictext_to_panel(panel_forme, "???" );

	FicForme->set_text(NomFichierForme);

	glui->add_column_to_panel(panel_forme, false);

	GLUI_Button *bouton =

		glui->add_button_to_panel(panel_forme, "Load", 0, ChargerFichierForme );

	bouton->set_w(10);



	/*choix projection orthogonale ou perspective*/

	GLUI_Panel *panel_proj = glui->add_panel("Projection" );

	GLUI_RadioGroup *radio_proj =

		glui->add_radiogroup_to_panel(panel_proj,&ProjOrthoPers,0,ModifProjection3d);

	glui->add_radiobutton_to_group( radio_proj, "Orthogonale" );

	glui->add_radiobutton_to_group( radio_proj, "Perspective" );

	/*choix visu symtriqe ou non*/

	glui->add_checkbox("symetrique",&VisuSymetrique,0,ModifVisuSymetrique);

	/*choix visu des points de suspentage*/

	glui->add_checkbox("pts suspentes",&VisuPtsSuspentes,0,ModifVisuSymetrique);

	

	/* bouton appliquer */

	glui->add_button( "Appliquer", 0, Appliquer );

	

	/* bouton Sauver au format Texte */

	glui->add_button( "Sauver TXT", 0, Sauver );



	/* bouton Sauver au format DXF */

	glui->add_button( "Sauver DXF", 1, Sauver );



	/* bouton quitter */

	glui->add_button( "Quitter", 0, Quitter );

	

	/* Link windows to GLUI, and register idle callback */

	glui->set_main_gfx_window( FenetrePatron );

	

	/* We register the idle callback with GLUI, not with GLUT */

	GLUI_Master.set_glutIdleFunc( NULL );

	

	/*init valeurs boite de dialogue*/

	InitValeursDialogue();



	/*premiers calculs et trace des axes*/

	CalculVue3dEtPatron();

	AxeSel = Axe3d;

	display();



	/*boucle glut*/

	glutMainLoop();

	return 0;
}
