/**************************************

* gestion chargement divers fichiers

* forme ,profil, patrons ...

***************************************/



#include <stdlib.h>

#include <stdio.h>

#include <string.h>

#include <conio.h>

#include <math.h>



#include <afx.h>		//class CString

#include <afxdlgs.h>	//class CFileDialog



#include "matrice.h"

#include "plot.h"

#include "fichier.h"



#define sqr(f1) ((f1)*(f1))



/////////////////////////////////////////////////////////////

// NOM TrouveMotDansFichierTexte

// Role: Recherche un mot dans un fichier texte

// Entree: Ptr sur le fichier Texte et Mot a rechercher

// Sortie: Ptr sur le fichier place apres le mot a rechercher

//		(pour pouvoir lire le texte suivant ce	mot)

//		ou code d'erreur si pas trouve:

//			TRUE si trouve, FALSE sinon

//////////////////////////////////////////////////////////////

int TrouveMotDansFichierTexte(FILE* fid, char* Mot)

{

	//var locale

	char Chaine[100];

	//retour au debut du fichier

	rewind(fid);

	//recherche du mot dans le fichier texte

	while ( ((fscanf(fid,"%s", Chaine))!= EOF) &&

		(strcmp(Chaine,Mot)!=0) ) {}

	//a-t-on trouve le mot ?

	if (strcmp(Chaine,Mot)!=0)

		return FALSE;

	else

		return TRUE;

}



/**************/

/* CreerForme */

/**************/

TForme* CreerForme(void)

{

	TForme *res;

	//allocation memoire

	res = (TForme*)malloc(sizeof(TForme));

	//valeurs par default

	res->CoeffProgGeom = 0.95f;

	res->EpaiRelCent = 17.0f;

	res->NbCaiss = 21;

	//init ptr tableaux a NULL

	res->mCtrlNez = NULL;

	res->mCtrlFui = NULL;

	res->mCtrlA = NULL;

	res->mCtrlB = NULL;

	res->mCtrlC = NULL;

	res->mCtrlD = NULL;

	res->mCtrlDiedre = NULL;

	res->mCtrlEpaiRel = NULL;

	res->mCtrlMorphing = NULL;

	res->mCtrlVrillage = NULL;

	res->TabForme = NULL;

	//nom des fichiers de profil

	strcpy(res->NomProfilBout,"");

	strcpy(res->NomProfilCent,"");

	return res;

}



/****************/

/* LibererForme */

/****************/

void LibererForme(TForme *f)

{

	LibererMatrice(f->mCtrlNez);

	LibererMatrice(f->mCtrlFui);

	LibererMatrice(f->mCtrlA);

	LibererMatrice(f->mCtrlB);

	LibererMatrice(f->mCtrlC);

	LibererMatrice(f->mCtrlD);

	LibererMatrice(f->mCtrlDiedre);

	LibererMatrice(f->mCtrlEpaiRel);

	LibererMatrice(f->mCtrlMorphing);

	LibererMatrice(f->mCtrlVrillage);

	LibererMatrice(f->TabForme);

	free(f);

}



/************************/

/* LectureFichierProfil */

/************************/

void LectureFichierProfil(char* NomProf, TMatrice** extrados, TMatrice** intrados)

{

	FILE *fid;

	char line[255];

	int NbInt, NbExt, i;

	float x,y,coeff;

	//rajoute pour format Selig ...

	int nbData, iNez;

	TMatrice *data;



	/* ouverture fichier profil */

	printf("\nLecture fichier profil: '%s'", NomProf);

	if( (fid = fopen( NomProf, "rt" )) == NULL )

	{

		printf( "\nErreur ouverture fichier: '%s'", NomProf );

		//fflush(stdin); getch();

	}

	else

	{

		/* lecture entete du fichier */

		if( fgets( line, 255, fid ) == NULL)

		{

			printf( "\nfgets error" );

			rewind(fid);

		}

		else 

			printf( "\n\tdescription: %s", line);



		//test format SELIG ou NACA ...

		fscanf(fid,"%f",&x);

		if(x==1.0f)

		{

			///////////////

			//FORMAT SELIG 

			///////////////

			

			//1ere lecture pour determiner le nombre de data

			nbData = 0;

			while( fscanf(fid,"%f %f", &x, &y) != EOF ) nbData++;

			//lecture des datas

			rewind(fid);

			fgets( line, 255, fid ); //premiere ligne

			data = CreerMatrice(nbData, 2);

			for(i=0; i<nbData; i++)

				fscanf( fid, "%f %f", &(data->t[i][0]), &(data->t[i][1]) );

			//determine position du nez !

			iNez = 0; x=10000.0f;

			for(i=0; i<nbData; i++)

			{

				if(x > data->t[i][0])

				{

					x=data->t[i][0];

					iNez=i;

				}

			}

			//recopie data dans le tableau d'extrados

			LibererMatrice(*extrados); NbExt = iNez+1;

			*extrados=CreerMatrice(NbExt,2);

			for(i=0; i<NbExt; i++)

			{

				(*extrados)->t[NbExt-i-1][0]=data->t[i][0];

				(*extrados)->t[NbExt-i-1][1]=data->t[i][1];

			}

			//recopie data dans le tableau d'intrados

			LibererMatrice(*intrados); NbInt = nbData-iNez;

			*intrados=CreerMatrice(NbInt,2);

			for(i=0; i<NbInt; i++)

			{

				(*intrados)->t[i][0]=data->t[i+NbExt-1][0];

				(*intrados)->t[i][1]=data->t[i+NbExt-1][1];

			}

			//liberation memoire

			LibererMatrice(data);

		}

		else

		{

			//////////////

			//FORMAT NACA

			//////////////

			

			// lecture nombre de points en intrados et extrados

			rewind(fid);

			fgets( line, 255, fid ); //premiere ligne

			fscanf(fid,"%f %f", &x, &y);

			NbExt=(int)floor(x);	NbInt=(int)floor(y);		

			// lecture pts Extrados

			LibererMatrice(*extrados);

			*extrados=CreerMatrice(NbExt,2);

			for(i=0; i<NbExt; i++)

				fscanf(fid,"%f %f", &((*extrados)->t[i][0]), &((*extrados)->t[i][1]) );

			// lecture pts Intrados

			LibererMatrice(*intrados);

			*intrados=CreerMatrice(NbInt,2);

			for(i=0; i<NbInt; i++)

				fscanf(fid,"%f %f", &((*intrados)->t[i][0]), &((*intrados)->t[i][1]) );

		}

		

		//fermeture fichier

		if(fclose(fid))

		{

			printf("\nProbleme  la fermeture du fichier '%s'", NomProf);

			fflush(stdin); getch();

		}



		//met bord d'attaque en x=0.0f

		if((*extrados)->t[0][0] != 0.0f){

			for(i=0; i<NbExt; i++) (*extrados)->t[i][0] -= (*extrados)->t[0][0];}

		if((*intrados)->t[0][0] != 0.0f){

			for(i=0; i<NbInt; i++) (*intrados)->t[i][0] -= (*intrados)->t[0][0];}

		

		//met bord de fuite en x=100.0f

		if((*extrados)->t[NbExt-1][0] != 100.0f)

		{

			coeff = 100.0f/(*extrados)->t[NbExt-1][0];

			for(i=0; i<NbExt; i++)

			{

				(*extrados)->t[i][0] *= coeff;

				(*extrados)->t[i][1] *= coeff;

			}

		}

		if((*intrados)->t[NbInt-1][0] != 100.0f)

		{

			coeff = 100.0f/(*intrados)->t[NbInt-1][0];

			for(i=0; i<NbInt; i++)

			{

				(*intrados)->t[i][0] *= coeff;

				(*intrados)->t[i][1] *= coeff;

			}

		}

	}

}



/***********************/

/* LectureFichierForme */

/***********************/

TForme* LectureFichierForme(char* NomFic)

{

	int i,j,n;

	FILE *fid;

	TMatrice *m;

	float noVer;

	TForme *f=NULL;

	//liste des mots clefs du fichier

	char* motsClef[17] = {"VERSION",

		"NB_ALVEOLES", "COEFF_PROG_GEOM", "EPAI_REL_CENTRE",

		"BORD_ATTAQUE_FORME","BORD_DE_FUITE_FORME","SUSPENTAGE_LIGNE_A",

		"SUSPENTAGE_LIGNE_B","SUSPENTAGE_LIGNE_C","SUSPENTAGE_LIGNE_D",

		"DIEDRE","MORPHING","VRILLAGE","EPAISSEUR_RELATIVE",

		"PROFIL_CENTRE", "PROFIL_BOUT", "TABLEAU_FORME" };

	

	/**** message ****/

	printf("\nLecture fichier de Forme: '%s'",NomFic);

	

	/**** ouverture fichier en lecture ****/

	if( (fid = fopen( NomFic, "rt" )) == NULL )

	{

		printf( "\nErreur ouverture fichier '%s'", NomFic);

	}

	else

	{

		/**** allocation memoire ****/

		f=CreerForme();

		

		/**** Lecture des points de controle ****/

		/*Boucle de lecture*/

		for (i=0; i<17; i++)

		{

			//recherche mot clef

			if(!TrouveMotDansFichierTexte(fid, motsClef[i]))

				printf("\n\tWarning: mot clef '%s' non trouv !", motsClef[i]);

			else

			{

				//action en fonction du mot clef

				switch(i)

				{

				case 0: fscanf(fid,"%f", &noVer); 

					//if(noVer==NO_VERSION)

					break;

				case 1: fscanf(fid,"%d", &(f->NbCaiss));break;

				case 2: fscanf(fid,"%f", &(f->CoeffProgGeom)); break;

				case 3: fscanf(fid,"%f", &(f->EpaiRelCent)); break;

				case 4:

				case 5:

				case 6:

				case 7:

				case 8:

				case 9:

				case 10:

				case 11:

				case 12:

				case 13:{

					m = CreerMatrice(4,2);

					fscanf(fid,"%f %f %f %f %f %f %f %f",

						&(m->t[0][0]),&(m->t[0][1]),

						&(m->t[1][0]),&(m->t[1][1]),

						&(m->t[2][0]),&(m->t[2][1]),

						&(m->t[3][0]),&(m->t[3][1]) );

					switch(i)

					{

					case 4: f->mCtrlNez = m; break;

					case 5: f->mCtrlFui = m; break;

					case 6: f->mCtrlA = m; break;

					case 7: f->mCtrlB = m; break;

					case 8: f->mCtrlC = m; break;

					case 9: f->mCtrlD = m; break;

					case 10: f->mCtrlDiedre = m; break;

					case 11: f->mCtrlMorphing = m; break;

					case 12: f->mCtrlVrillage = m; break;

					case 13: f->mCtrlEpaiRel = m; break;

					default:;

					}

					break;}

				case 14: fscanf(fid,"%s",f->NomProfilCent); break;

				case 15: fscanf(fid,"%s",f->NomProfilBout); break;

				case 16:

					LibererMatrice(f->TabForme);

					fscanf(fid,"\n%d",&n);

						//fscanf(fid,"%d",&n);

						f->TabForme = Zeros(n,12);				

						//boucle  partir de la 1ere nervure du centre vers l'extrmit

						for (j=0; j<f->TabForme->lig; j++)

						{

							fscanf(fid,"\n%d %f %f %f %f %f %f %f %f %f %f %f %f",

								&n,							//no Nervure

								&(f->TabForme->t[j][0]),	//longueur

								&(f->TabForme->t[j][1]),	//epaisseur relative

								&(f->TabForme->t[j][2]),	//xnez

								&(f->TabForme->t[j][3]),	//ynez

								&(f->TabForme->t[j][4]),	//znez

								&(f->TabForme->t[j][5]),	//inclinaison / horizontale

								&(f->TabForme->t[j][6]),	//vrillage / horizontale

								&(f->TabForme->t[j][7]),	//morphing / nervure centrale

								&(f->TabForme->t[j][8]),	//pos relative ligne A

								&(f->TabForme->t[j][9]),	//pos relative ligne B

								&(f->TabForme->t[j][10]),	//pos relative ligne C

								&(f->TabForme->t[j][11]));	//pos relative ligne D

							//conversion en radian

							f->TabForme->t[j][5]*=DEG2RAD;	//inclinaison

							f->TabForme->t[j][6]*=DEG2RAD;	//vrillage	

						}//boucle lecture tableau de forme

						break;

					default:;

				}//switch mot clef

			}//test trouve mot clef

		}//boucle

		

		/**** fermeture fichier ****/

		if(fclose(fid))

		{

			printf("\nProbleme  la fermeture du fichier");

		}

	}//test ouverture fichier ok

	return f;

}



/************************/

/* EcritureFichierForme */

/************************/

void EcritureFichierForme(char *NomFichier, TForme *f)

{

	int i;

	FILE *fid;

	char* texte[10]={"BORD_ATTAQUE_FORME","BORD_DE_FUITE_FORME","SUSPENTAGE_LIGNE_A",

		"SUSPENTAGE_LIGNE_B","SUSPENTAGE_LIGNE_C","SUSPENTAGE_LIGNE_D",

		"DIEDRE","MORPHING","VRILLAGE","EPAISSEUR_RELATIVE"};

	TMatrice* m[10];



	/**** message ****/

	printf("\nEcriture fichier de Forme: '%s'",NomFichier);



	/**** ouverture fichier en ecriture ****/

	if( (fid = fopen( NomFichier, "wt" )) == NULL )

	{

		printf( "\nErreur ouverture fichier '%s'", NomFichier);

		exit(0);

	}

	

	/**** Ecriture No de version ****/

	

	fprintf(fid,"\nVERSION %1.2f", NO_VERSION);

	

	/**** Ecriture des parametres ****/

	

	fprintf(fid,"\n\nNB_ALVEOLES %d", f->NbCaiss);

	fprintf(fid,"\nCOEFF_PROG_GEOM %1.5f", f->CoeffProgGeom);

	fprintf(fid,"\nEPAI_REL_CENTRE %2.3f", f->EpaiRelCent);

	

	/**** Ecriture des points de controle ****/

	

	/*init pointeur des matrices de coordonnes des points de controle*/

	m [0]=f->mCtrlNez; m [1]=f->mCtrlFui;

	m [2]=f->mCtrlA; m [3]=f->mCtrlB; m [4]=f->mCtrlC; m [5]=f->mCtrlD;

	m [6]=f->mCtrlDiedre; m [7]=f->mCtrlMorphing;

	m [8]=f->mCtrlVrillage; m [9]=f->mCtrlEpaiRel;

	

	/*boucle ecriture des points de controle*/

	for (i=0; i<10; i++)

		fprintf(fid,"\n%s %1.3f %1.3f  %1.3f %1.3f  %1.3f %1.3f  %1.3f %1.3f",

		texte[i],

		m [i]->t[0][0], m [i]->t[0][1],

		m [i]->t[1][0], m [i]->t[1][1],

		m [i]->t[2][0], m [i]->t[2][1],

		m [i]->t[3][0], m [i]->t[3][1]);

	

	/**** Ecriture noms des profils ****/



	fprintf(fid,"\n\nPROFIL_CENTRE %s", f->NomProfilCent);

	fprintf(fid,"\nPROFIL_BOUT %s", f->NomProfilBout);



	/**** Ecriture du tableau de forme ****/

	

	fprintf(fid,"\n\nTABLEAU_FORME %d",f->TabForme->lig);

	/*boucle  partir de la 1ere nervure du centre vers l'extrmit*/

	for (i=0; i<f->TabForme->lig; i++)

	{

		fprintf(fid,

			"\n%d %1.3f %2.2f %2.3f %2.3f %2.3f %1.2f %1.2f %1.2f %3.1f %3.1f %3.1f %3.1f",

			i+1,							//no Nervure

			f->TabForme->t[i][0],			//longueur

			f->TabForme->t[i][1],			//epaisseur relative

			f->TabForme->t[i][2],			//xnez

			f->TabForme->t[i][3],			//ynez

			f->TabForme->t[i][4],			//znez

			f->TabForme->t[i][5]*RAD2DEG,	//inclinaison / horizontale

			f->TabForme->t[i][6]*RAD2DEG,	//vrillage / horizontale

			f->TabForme->t[i][7],			//morphing / nervure centrale

			f->TabForme->t[i][8],			//pos relative ligne A

			f->TabForme->t[i][9],			//pos relative ligne B

			f->TabForme->t[i][10],			//pos relative ligne C

			f->TabForme->t[i][11]);			//pos relative ligne D

	}

	

	/**** fermeture fichier ****/

	if(fclose(fid))

	{

		printf("\nProbleme  la fermeture du fichier");

		exit(0);

	}

}



/********************/

/* CalculInfoForme */

/********************/

void CalculInfoForme( TForme* F, TInfoForme* info )

{

	float xNerv, xNervPrec, lNerv, lNervPrec, larg;

	int i, nNerv;

	TMatrice *tabXNerv;



	/*calcul position nervures a plat*/

	nNerv = F->TabForme->lig;

	tabXNerv = CreerMatrice(nNerv,1);

	tabXNerv->t[0][0] = F->TabForme->t[0][2];

	for(i=1; i<nNerv; i++)

	{

		tabXNerv->t[i][0] = tabXNerv->t[i-1][0]

			+ (float)sqrt(sqr(F->TabForme->t[i][2] - F->TabForme->t[i-1][2])

			+ sqr(F->TabForme->t[i][3] - F->TabForme->t[i-1][3]));

	}



	/*envergure*/

	info->envergure =  2.0f * tabXNerv->t[nNerv-1][0];

	/*surface*/

	info->surface = 0.0f; xNervPrec = 0.0f;

	lNervPrec = F->TabForme->t[0][0];

	for(i=0; i<nNerv; i++)

	{

		lNerv = F->TabForme->t[i][0];

		xNerv = tabXNerv->t[i][0];

		info->surface += (lNerv + lNervPrec) * (xNerv - xNervPrec);

		lNervPrec = lNerv; xNervPrec = xNerv;

	}

	/*allongement*/

	info->allongement=sqr(info->envergure)/info->surface;



	/*envergure projete*/

	info->envergureProj =  2.0f * F->TabForme->t[nNerv-1][2];

	/*surface projete*/

	info->surfaceProj = 0.0f; xNervPrec = 0.0f;

	lNervPrec = F->TabForme->t[0][0];

	for(i=0; i<nNerv; i++)

	{

		lNerv = F->TabForme->t[i][0];

		xNerv = F->TabForme->t[i][2];

		info->surfaceProj += (lNerv + lNervPrec) * (xNerv - xNervPrec);

		lNervPrec = lNerv; xNervPrec = xNerv;

	}

	/*allongement projet*/

	info->allongementProj=sqr(info->envergureProj)/info->surfaceProj;



	/*corde max et min*/

	info->cordeMin = 100000.0f; info->cordeMax = 0.0f;

	for(i=0; i<nNerv; i++)

	{

		lNerv = F->TabForme->t[i][0];

		if(info->cordeMin > lNerv) info->cordeMin = lNerv;

		if(info->cordeMax < lNerv) info->cordeMax = lNerv;

	}

	

	/*largeur caisson min et max*/

	info->largMin = 10000.0f;

	info->largMax = tabXNerv->t[0][0] * 2.0f; //par defaut = largeur en central

	for(i=1; i<nNerv; i++)

	{

		larg = tabXNerv->t[i][0] - tabXNerv->t[i-1][0];

		if(info->largMin > larg) info->largMin = larg;

		if(info->largMax < larg) info->largMax = larg;

	}



	/*liberation memoire*/

	LibererMatrice(tabXNerv);

}



/********************/

/* AfficheInfoForme */

/********************/

void AfficheInfoForme( TInfoForme info )

{

	printf("\n\nINFO:");

	printf("\n\tSurface: plat=%2.2fm2, proj=%2.2fm2, r=%2.1f%%",

		info.surface, info.surfaceProj, info.surfaceProj/info.surface*100.0f);

	printf("\n\tEnvergure: plat=%2.2fm, proj=%2.2fm, r=%2.1f%%",

		info.envergure, info.envergureProj, info.envergureProj/info.envergure*100.0f);

	printf("\n\tAllongement: plat=%2.2f, proj=%2.2f, r=%2.1f%%",

		info.allongement, info.allongementProj, info.allongementProj/info.allongement*100.0f);

	printf("\n\tCorde mini = %2.3fm, maxi = %2.3fm", info.cordeMin, info.cordeMax);

	printf("\n\tLarg caisson mini = %2.3fm, maxi = %2.3fm", info.largMin, info.largMax);

}



/*****************/

/* EcritLigneDXF */

/*****************/

void EcritLigneDXF(FILE *fid, char *nom, int en3d,

				   float x1, float y1, float z1,

				   float x2, float y2, float z2)

{

	fprintf(fid,"0\nLINE\n8\n%s\n10\n%3.3f\n20\n%3.3f\n", nom, x1*1000.0f, y1*1000.0f);

	if(en3d) fprintf(fid,"30\n%3.3f\n", z1*1000.0f);

	fprintf(fid,"11\n%3.3f\n21\n%3.3f\n", x2*1000.0f, y2*1000.0f);

	if(en3d) fprintf(fid,"31\n%3.3f\n", z2*1000.0f);

}



/**********************/

/* EcritureFichierDXF */

/**********************/

void EcritureFichierDXF(char *NomFichier, TAxe *axe)

{

	int i, j, cpt;

	FILE *fid;

	TCourbe *courb;

	TMesh *mesh;

	char text[50];



	/**** message ****/

	printf("\nEcriture fichier de DXF: '%s'",NomFichier);



	/**** ouverture fichier en ecriture ****/

	if( (fid = fopen( NomFichier, "wt" )) == NULL )

	{

		printf( "\nErreur ouverture fichier '%s'", NomFichier);

		exit(0);

	}

	

	/**** ecriture DXF *****/



	/* entete DXF minimal !!! */

    fprintf(fid,"0\nSECTION\n2\nENTITIES\n");



	/*ecriture courbes*/

	courb=axe->Courb; cpt=0;

	while (courb!=NULL)

	{

		cpt++; sprintf(text, "COURB%03d", cpt);

		for(i=0; i<courb->pts->lig-1; i++)

		{

			EcritLigneDXF(fid, text, axe->axe3d,

				courb->pts->t[i][0], courb->pts->t[i][1], courb->pts->t[i][2],

				courb->pts->t[i+1][0], courb->pts->t[i+1][1], courb->pts->t[i+1][2]);

		}

		courb=courb->CourbSuiv;

	}



	/*ecriture meshs*/

	mesh=axe->Mesh; cpt=0;

	while (mesh!=NULL)

	{

		cpt++; sprintf(text, "MESH%03d", cpt);

		for(i=0; i<mesh->x->lig-1; i++)

			for(j=0; j<mesh->x->col-1; j++)

			{

				EcritLigneDXF(fid, text, axe->axe3d,

					mesh->x->t[i][j], mesh->y->t[i][j], mesh->z->t[i][j],

					mesh->x->t[i][j+1], mesh->y->t[i][j+1], mesh->z->t[i][j+1]);

				EcritLigneDXF(fid, text, axe->axe3d,

					mesh->x->t[i][j], mesh->y->t[i][j], mesh->z->t[i][j],

					mesh->x->t[i+1][j], mesh->y->t[i+1][j], mesh->z->t[i+1][j]);

				if (i==mesh->x->lig-2)

					EcritLigneDXF(fid, text, axe->axe3d,

					mesh->x->t[i+1][j], mesh->y->t[i+1][j], mesh->z->t[i+1][j],

					mesh->x->t[i+1][j+1], mesh->y->t[i+1][j+1], mesh->z->t[i+1][j+1]);

				if (j==mesh->x->col-2)

					EcritLigneDXF(fid, text, axe->axe3d,

					mesh->x->t[i][j+1], mesh->y->t[i][j+1], mesh->z->t[i][j+1],

					mesh->x->t[i+1][j+1], mesh->y->t[i+1][j+1], mesh->z->t[i+1][j+1]);

			}

			mesh=mesh->MeshSuiv;

	}

	



	/*fin DXF*/

    fprintf(fid,"0\nENDSEC\n0\nEOF\n");





	/**** fermeture fichier ****/

	if(fclose(fid))

	{

		printf("\nProbleme  la fermeture du fichier");

		exit(0);

	}

}