/***********************/

/* header de fichier.c */

/***********************/



#define NO_VERSION 0.1f

#define DEG2RAD	(3.1415926f/180.0f)

#define RAD2DEG	(180.0f/3.1415926f)



/*********/

/* types */

/*********/



//structure de forme

typedef struct Forme TForme;

struct Forme

{

	//parametres principaux

	float CoeffProgGeom; //coeff progression gomtrique

	float EpaiRelCent;	//epaisseur relative du profil central 

	int NbCaiss;	//nombre des alvoles

	//points de controle = courbes de 4 pts(x,y)

	TMatrice *mCtrlNez, *mCtrlFui, *mCtrlA, *mCtrlB, *mCtrlC, *mCtrlD;

	TMatrice *mCtrlDiedre, *mCtrlMorphing, *mCtrlVrillage, *mCtrlEpaiRel;

	//nom des profils central/extremite

	char NomProfilCent[255], NomProfilBout[255];

	//tableau de forme

	TMatrice *TabForme;

};



//structure info de la forme

typedef struct InfoForme TInfoForme;

struct InfoForme

{

	float surface, envergure;

	float surfaceProj, envergureProj;

	float allongement, allongementProj;

	float cordeMin, cordeMax;

	float largMin, largMax;

};



/**************/

/* procedures */

/**************/

TForme* CreerForme(void);

void LibererForme(TForme *f);

void LectureFichierProfil(char* NomProf, TMatrice** extrados, TMatrice** intrados);

TForme* LectureFichierForme(char* NomFic);

void EcritureFichierForme(char *NomFichier, TForme *f);

int TrouveMotDansFichierTexte(FILE* fid, char* Mot);

void EcritureFichierDXF(char *NomFichier, TAxe *axe);

void CalculInfoForme( TForme* F, TInfoForme* info );

void AfficheInfoForme( TInfoForme info );

