/*************************************/

/* def type matrice et operateurs ...*/

/*************************************/



#include <stdlib.h>

#include <stdio.h>

#include <conio.h>

#include <math.h>

#include "matrice.h"



/************************************/

/* allocation espace pour matrice   */

/************************************/

TMatrice* CreerMatrice(int lig, int col)

{

	int l;

	TMatrice *res;

	res = (TMatrice*)malloc(sizeof(TMatrice));

	res->t = (float **)malloc(lig*sizeof(float*));

	if (res->t == NULL)

	{

		printf ("erreur d'allocation de memoire (ligne)\n") ;

		exit (0) ;

	}

	for(l=0; l<lig; l++)

	{

		res->t[l] = (float*)malloc(col*sizeof(float));

		if (res->t[l] == NULL)

		{

			printf ("erreur d'allocation de memoire (colonne)\n") ;

			exit (0) ;

		}

	}

	res->lig = lig; res->col = col;

	return res;

}



/***********************************/

/* liberation espace de la matrice */

/***********************************/

void LibererMatrice(TMatrice *m)

{

	int l;

	if(m!=NULL)

	{

		for(l=0; l<m->lig; l++) free(m->t[l]);

		free(m->t);

		free(m);

	}



}



/********************************/

/* addition de deux matrices	*/

/********************************/

TMatrice* AddMat(TMatrice *m1,TMatrice *m2)

{

	int l,c;

	TMatrice *res;

	

	res = NULL;

	if(m1==NULL)

		printf("erreur fonction AddMat: matrice m1 = NULL !!!");

	else if(m2==NULL)

		printf("erreur fonction AddMat: matrice m2 = NULL !!!");

	else

	{

		/*test coherence des tailles*/

		if ((m1->lig != m2->lig)||(m1->col != m2->col))

		{

			res=NULL;

			printf("\n erreur fonction AddMat: tailles diffrentes");

		}

		else

		{

			res=CreerMatrice(m1->lig,m1->col);

			for(l=0; l<m1->lig; l++)

				for(c=0; c<m1->col; c++)

					res->t[l][c] = m1->t[l][c] + m2->t[l][c];

		}

	}

	return res;

}



/************************************/

/* addition d'un rel  une matrice */

/************************************/

TMatrice* AddReelMat(TMatrice *m, float reel)

{

	int l,c;

	TMatrice *res;



	res = NULL;

	if (m==NULL)

		printf("erreur fonction AddReelMat: m = NULL !!!");

	else

	{

		res=CreerMatrice(m->lig,m->col);

		for(l=0; l<m->lig; l++)

			for(c=0; c<m->col; c++)

				res->t[l][c] = m->t[l][c] + reel;

	}

	return res;

}



/************************************/

/* multiplication de deux matrices	*/

/************************************/

TMatrice* MultMat(TMatrice *m1,TMatrice *m2)

{

	int l,c,c1;

	TMatrice *res;

	float accu;

	

	res = NULL;

	if(m1==NULL)

		printf("erreur fonction MultMat: m1 = NULL !!!");

	else if(m2==NULL)

		printf("erreur fonction MultMat: m2 = NULL !!!");

	else

	{

		if(m1->col != m2->lig)

			printf("erreur dimension procedure MultMat");

		else

		{

			res=CreerMatrice(m1->lig,m2->col);

			for(l=0; l<m1->lig; l++)

				for(c=0; c<m2->col; c++)

				{

					accu=0.0F;

					for(c1=0; c1<m1->col; c1++)

						accu += m1->t[l][c1] * m2->t[c1][c];

					res->t[l][c]=accu;

				}

		}

	}

	return res;

}





/********************************************/

/* multiplication d'une matrice par un reel */

/********************************************/

TMatrice * MultReelMat(TMatrice *m, float reel)

{

	int l,c;

	TMatrice *res;

	

	if (m!=NULL)

	{

		res = CreerMatrice(m->lig, m->col);

		for(l=0; l<m->lig; l++)

			for(c=0; c<m->col; c++)

				res->t[l][c] = m->t[l][c] * reel;

	}

	return res;

}



/********************************************/

/* cre une matrice ligne contenant des     */

/* reels linairement espac entre 2 bornes */

/********************************************/

TMatrice* LinSpace(float deb, float fin, int n)

{

	float pas, accu;

	int i;

	TMatrice *res;

	res=CreerMatrice(n,1);

	

	pas=(fin-deb)/(n-1); accu=deb;

	for(i=0; i<n; i++)

	{

		res->t[i][0]=accu;

		accu+=pas;

	}

	res->t[n-1][0]=fin; /*si erreur d'arrondi*/

	return res;

}



/***********************************************/

/* cre une matrice ne contenant que des zeros */

/***********************************************/

TMatrice* Zeros(int lig, int col)

{

	int l,c;

	TMatrice *res;

	res=CreerMatrice(lig,col);

	for(l=0; l<lig; l++)

		for(c=0; c<col; c++) res->t[l][c]=0.0;

	return res;

}



/***********************************************/

/* cre une matrice ne contenant que des uns   */

/***********************************************/

TMatrice* Ones(int lig, int col)

{

	int l,c;

	TMatrice *res;

	res=CreerMatrice(lig,col);

	for(l=0; l<lig; l++)

		for(c=0; c<col; c++) res->t[l][c]=1.0;

	return res;

}



/************************************/

/* affecte une matrice a une autre  */

/************************************/

void AffecteMat(TMatrice **dst, TMatrice *src)

{

	if(*dst!=NULL) LibererMatrice(*dst);

	*dst=src;

}



/*********************************************************/

/* copie tous les elements d'une matrice dans une autre  */

/*********************************************************/

void CopierMat(TMatrice *dst, TMatrice *src)

{

	int l,c;



	if(src==NULL)

		printf("erreur fonction CopierMat: src = NULL !!!");

	else if(dst==NULL)

		printf("erreur fonction CopierMat: dst = NULL !!!");

	else

		if((dst->lig != src->lig)||(dst->col != src->col))

			printf("erreur dimension procedure CopierMat");

		else

			for(l=0; l<src->lig; l++)

				for(c=0; c<src->col; c++)

					dst->t[l][c]=src->t[l][c];

}



/********************************/

/* cree une copie d'une matrice */

/********************************/

TMatrice* CloneMat(TMatrice *src)

{

	int l,c;

	TMatrice *dst;



	dst = NULL;

	if(src==NULL)

		printf("erreur fonction CopierMat: src = NULL !!!");

	else

	{

		dst = CreerMatrice(src->lig,src->col);

		for(l=0; l<src->lig; l++)

			for(c=0; c<src->col; c++) dst->t[l][c] = src->t[l][c];

	}

	return dst;

}



/****************************************************/

/* copie les elements d'une matrice dans une autre  */

/* avec indices de debut et fin pour lig et col     */

/* pour la matrice destination et source

/****************************************************/

void CopierMatInd(TMatrice *dst, int lDebDst, int lFinDst,int cDebDst, int cFinDst,

				  TMatrice *src, int lDebSrc, int lFinSrc,int cDebSrc, int cFinSrc)

{

	int l,c,dl,dc;



	if(src==NULL)

		printf("erreur fonction CopierMatInd: src = NULL !!!");

	else if(dst==NULL)

		printf("erreur fonction CopierMatInd: dst = NULL !!!");

	else

	{

		dl = lFinDst - lDebDst; dc = cFinDst - cDebDst;

		/*test coherence dimensions*/

		if ((dl != lFinSrc - lDebSrc) || (dc != cFinSrc - cDebSrc)

			||(dst->lig < lFinDst)||(dst->col < cFinDst)

			||(src->lig < lFinSrc)||(src->col < lFinSrc)

			||(dl<0)||(dc<0))

			printf("erreur dimension procedure CopierMatInd");

		else

			for(l=0; l<dl+1; l++)

				for(c=0; c<dc+1; c++)

					dst->t[l+lDebDst][c+cDebDst]=src->t[l+lDebSrc][c+cDebSrc];

	}

}



/************************************/

/* visualise une matrice            */

/************************************/

void VoirMat(TMatrice *m)

{

	int l,c, cpt;

	if(m==NULL) 

		printf("\n erreur fonction VoirMat: m = NULL !!!");

	else

	{

		cpt=0;

		for(l=0; l<m->lig; l++)

		{

			for(c=0; c<m->col; c++)

			{

				printf("\nm[%d][%d]=%f",l,c,m->t[l][c]);

				if(cpt++ == 20)

					{printf("\n<pause - suite>"); fflush(stdin); getch(); cpt=0;}

			}

		}

	}

	printf("\n<pause - fin>"); fflush(stdin); getch();

}



/*****************/

/* InterpLinMat  */

/*****************/

/*void InterpLinMat(TMatrice *m, TMatrice *mi)*/

void InterpLinMat(TMatrice *x, TMatrice *y, TMatrice *xi, TMatrice *yi)

{

	int i, ipc; /*indice point courant*/



	/*test matrices non nulle*/

	if(x==NULL) 

		printf("\n erreur fonction InterpLinMat: x = NULL !!!");

	else if(y==NULL) 

		printf("\n erreur fonction InterpLinMat: y = NULL !!!");

	else if(xi==NULL) 

		printf("\n erreur fonction InterpLinMat: xi = NULL !!!");

	else if(yi==NULL) 

		printf("\n erreur fonction InterpLinMat: yi = NULL !!!");

	else

	{

		ipc=0;

		for(i=0; i<xi->lig; i++)

		{

			/*recherche indice pts avant/apres*/

			while((x->t[ipc][0] <= xi->t[i][0])&&(ipc<x->lig-1)) ipc++;

			if(ipc>0) ipc--; 

			yi->t[i][0] = y->t[ipc][0] + (y->t[ipc+1][0] - y->t[ipc][0])

				*(xi->t[i][0] - x->t[ipc][0])/(x->t[ipc+1][0] - x->t[ipc][0]);

		}

	}

}



/***************/

/* InterpLinX  */

/***************/

float InterpLinX(TMatrice *m, float xi)

{

	int ipc; /*indice point courant*/

	float yi=0.0f;

	

	

	/*test matrices non nulle*/

	if(m==NULL) 

		printf("\n erreur fonction InterpLinX: m = NULL !!!");

	else

	{

		/*recherche indice pts avant/apres*/

		ipc=0; while((m->t[ipc][0] <= xi)&&(ipc<m->lig-1)) ipc++;

		if(ipc>0) ipc--; 

		/*interpole y*/

		yi = m->t[ipc][1] + (m->t[ipc+1][1] - m->t[ipc][1])

				*(xi - m->t[ipc][0])/(m->t[ipc+1][0] - m->t[ipc][0]);

	}

	return yi;

}



/******************************************************/

/* cree une sous-matrice extraite d'une autre matrice */

/******************************************************/

TMatrice* ExtraitMat(TMatrice *m, int lDeb, int lFin,int cDeb, int cFin)

{

	int l,c,dl,dc;

	TMatrice* res;



	res=NULL;

	if(m==NULL)

		printf("erreur fonction ExtraitMat: m = NULL !!!");

	else

	{

		dl = lFin - lDeb; dc = cFin - cDeb;

		/*test coherence dimensions*/

		if ( (m->lig < lFin) || (m->col < cFin) || (dl<0) || (dc<0) )

			printf("erreur dimension procedure ExtraitMat");

		else

		{

			res = CreerMatrice(dl+1,dc+1);

			for(l=0; l<dl+1; l++)

				for(c=0; c<dc+1; c++)

					res->t[l][c]=m->t[l+lDeb][c+cDeb];

		}

	}

	return res;

}



/******************************************************/

/* donne l'indice d'une valeur d'un tableau ou de sa  */

/* valeur la plus proche                              */

/******************************************************/

void Ind(float val, TMatrice *m, int *lig, int *col)

{

	float mini, dist;

	int l,c,lmini,cmini;

	mini = 10000000000000000.0f;

	lmini=0; cmini=0;

	for(l=0; l<m->lig; l++)

	{

		for(c=0; c<m->col; c++)

		{

			dist=(float)fabs(val - m->t[l][c]);

			if(mini>dist){mini=dist; lmini=l; cmini=c;}

		}

	}

	*lig=lmini; *col=cmini;

}



/******************************************************/

/* indique si une valeur est prsente dans un tableau */

/******************************************************/

int ValeurPresente(float val, TMatrice *m)

{

	int l,c;

	int res = false;

	for(l=0; l<m->lig; l++){

		for(c=0; c<m->col; c++){

			if(val == m->t[l][c]) {res = true; break;}}}

	return res;

}



/*****************************************************************/

/* ajoute une valeur dans un vecteur colonne par ordre croissant */

/*****************************************************************/

void AjouteValeurCroissant(float val, TMatrice **m)

{

	int l,i;

	TMatrice *res;

	res=CreerMatrice((*m)->lig+1, (*m)->col);

	if(val < (*m)->t[0][0]) //ajout devant ?

	{

		res->t[0][0] = val;

		for(l=0; l<(*m)->lig; l++) res->t[l+1][0] = (*m)->t[l][0];

	}

	else if (val>(*m)->t[(*m)->lig-1][0]) //ajout derriere ?

	{

		for(l=0; l<(*m)->lig; l++) res->t[l][0] = (*m)->t[l][0];

		res->t[l][0]=val;

	}

	else //ajout dans le tableau

	{

		l=0;

		while(val>(*m)->t[l][0]){ res->t[l][0] = (*m)->t[l][0]; l++;}

		res->t[l][0] = val;

		for(i=l+1; i<res->lig; i++) res->t[i][0] = (*m)->t[i-1][0];

	}

	//mise a jour pointeurs ...

	LibererMatrice(*m);

	*m=res;

}



/*****************************************************************

* This is a gaussian elimination program with pivoting.          *

* The matrix is in an array called a; which is an n by n+1 array.*

* The choice of pivots is kept in an array called                *

* row[].                                                         *

* procdure rcupre sur internet et adapte  mes besoins pour *

* la resolution du systeme: A . x = B 

******************************************************************/

void ResolutionGauss(TMatrice *A, TMatrice *B, TMatrice **x)

{

	int n, n1, j, j1, l, i, i1, p, trow;

	TMatrice *a, *row;

	float temp, temp1, mult, sum;

	

	//init var n et n1

	n=A->lig; n1=n-1;

	

	//init matrice a

	a=Zeros(n, n+1);

	for(i=0; i<n; i++)

	{

		a->t[i][n] = B->t[i][0];

		for(j=0 ;j<n; j++) a->t[i][j] = A->t[i][j];

	}

	

	/*initialize the array row*/

	row=Zeros(n,1);

	for(i=0;i<=n1;i++) row->t[i][0]=(float)i;

	

	/*This outermost of 3 loops that performs the elimination step */

	for(i=0; i<=n1;i++) 

	{

		/* First, find the choice of pivot */

		p=i;

		n1=n-1;

		i1=i+1;

		temp=(float)fabs(a->t[(int)row->t[i][0]][i]);

		for(j=i1;j<n;j++)

		{

			if((temp1=(float)fabs(a->t[(int)row->t[j][0]][i]))>temp)

			{

				p=j; temp=temp1;

			}

		}

		if(temp<1.E-9) {printf("no solution is likely \n"); return;}

		/* The largest pivot value is in temp and p is the

		corresponding index of the array row.

		If the largest pivot is small (< 10^(-9)), then

		a message is printed that no solution is likely, or can be trusted*/

		

		/*This step performs a simulated row switch by switching

		the values of row->t[i] with row->t[p] */

		trow=(int)row->t[i][0];

		row->t[i][0]=row->t[p][0];

		row->t[p][0]=(float)trow;

		/* This is the elimination step */

		for(j=i1; j<=n1;j++)

		{

			j1=j+1;

			mult = a->t[(int)row->t[j][0]][i] / a->t[(int)row->t[i][0]][i];

			for(l=i1;l<=n;l++)

			{

				a->t[(int)row->t[j][0]][l] = a->t[(int)row->t[j][0]][l]

					- mult*a->t[(int)row->t[i][0]][l];}

		}

	}

	

	/* Now initialize the solution array, x->t[] */

	//for(k=0;k<=n1;k++) x->t[k][0]=0.0;

	*x=Zeros(n,1);

	

	/* Now perform back substitution

	to calculate the solutions, x->t[k][0]*/

	n1=n-1;

	(*x)->t[n1][0] = a->t[(int)row->t[n1][0]][n] / a->t[(int)row->t[n1][0]][n1];

	for(i=2;i<=n;i++)

	{

		sum=0;

		for(j=n-i+1;j<n;j++) sum = sum + a->t[(int)row->t[n-i][0]][j] * (*x)->t[j][0];

		(*x)->t[n-i][0]=(a->t[(int)row->t[n-i][0]][n]-sum) / a->t[(int)row->t[n-i][0]][n-i];

	}

	

	//liberation matrice de calcul

	LibererMatrice(row); LibererMatrice(a);

}

