/* header de plot.c */



/*pour activer ou desactiver une fonction*/

#define ON 1

#define OFF 0



/*definition des diffrents type de courbe*/

#define NON_DEF		0

#define	CTRL_POINT	1



/*def des type de projection*/

#define PROJ_ORTHOGONALE 0 /*orthogonale*/

#define PROJ_PERSPECTIVE 1 /*perspective*/



#define DEG2RAD	(3.1415926f/180.0f)

#define RAD2DEG	(180.0f/3.1415926f)



/*****************************/

/*structure de courbe chaine*/

/*****************************/

typedef struct Courbe TCourbe;

struct Courbe

{

	int type; /*type de courbe: 0: non defini, 1: point de controle*/

	int points, segments;	/*1 pour visible, 0 sinon*/

	int symX; /*trace courbe symtrique /axe X: 0:OFF, 1:ON*/

	int symY; /*trace courbe symtrique /axe Y: 0:OFF, 1:ON*/

	int symZ; /*trace courbe symtrique /axe Y: 0:OFF, 1:ON si axe3d*/

	int alt; /*alterne segment et vide au trac*/

	float CouleurSegments[3];

	float CouleurPoints[3];

	TMatrice *pts;		/*matrice des points de la courbe*/

	TCourbe *CourbSuiv;	/*pointeur vers la courbe suivante de l'axe courant*/

};



/**************************************/

/*structure de mesh (maillage) chaine*/

/**************************************/

typedef struct Mesh TMesh;

struct Mesh

{

	int points, segments, faces;	/*1 pour visible, 0 sinon*/

	int symX; /*trace courbe symtrique /axe X: 0:OFF, 1:ON*/

	int symY; /*trace courbe symtrique /axe Y: 0:OFF, 1:ON*/

	int symZ; /*trace courbe symtrique /axe Y: 0:OFF, 1:ON si axe3d*/

	float CouleurFaces[3];

	float CouleurSegments[3];

	float CouleurPoints[3];

	int InvNormales;	/*inversion normale ON ou OFF*/

	TMatrice *x, *y, *z;

	TMesh *MeshSuiv;	/*pointeur vers la courbe suivante de l'axe courant*/

};



/**************************/

/*structure d'axe 2d ou 3d*/

/**************************/

typedef struct Axe  TAxe;

struct Axe

{

	int fenetre;	/*numero fenetre contenant l'axe*/

	int axe3d;		/*0: axe 2d, 1:axe 3d*/

	float xmin,xmax,ymin,ymax,zmin,zmax;	/*valeur min et max des axes*/

	float CouleurFond[3];

	float CouleurGrid[3];

	float CouleurRep[3];

	int XAuto, YAuto, ZAuto;	/*auto-ajustement des axes*/

	int Norme;					/*axes norms*/

	int XGrid, YGrid, ZGrid;	/*0: pas de graduation, 1: graduation*/

	float xcam, ycam, zcam, twist, incidence, azimuth; /*position camera dans la vue 3d*/

	int eclairage;	/*parametres d'clairage OpenGL: 0:dsactiv, 1:actif*/

	int proj;		/*type de projection*/

	TCourbe *Courb;	/*liste des courbes de l'axe*/

	TMesh *Mesh;	/*liste des mesh de l'axe*/

};



/************/

/*procedures*/

/************/

TAxe* CreerAxe(int fen);

TCourbe* CreerCourbe(void);

TMesh* CreerMesh(void);



void AjoutCourbe(TAxe *axe, TCourbe *courbe);

void AjoutMesh(TAxe *axe, TMesh *mesh);

void VisuAxe(TAxe *axe);



void LibererAxe(TAxe *axe);

void LibererCourbe(TCourbe *courbe);

void LibererMesh(TMesh *mesh);



void LibererCourbesAxe(TAxe *axe);

void LibererMeshsAxe(TAxe *axe);



void AjoutTexte(TAxe *axe, char *texte, float taille, float orientation, float posx, float posy);



void AjoutForme3D( TAxe *Axe3d, 

			 TMatrice *XExt, TMatrice *YExt, TMatrice *ZExt,

			 TMatrice *XInt, TMatrice *YInt, TMatrice *ZInt,

			 int mesh, int symetrie);



void AjoutPtsSuspentage(

						TAxe *Axe3d, TMatrice *TabForme, TMatrice *IntProfCent,

						TMatrice *XExt, TMatrice *YExt, TMatrice *ZExt,

						TMatrice *XInt, TMatrice *YInt, TMatrice *ZInt,

						int symetrie, TMatrice **PosPtsSuspente);



